/* A Bison parser, made by GNU Bison 2.4.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006,
   2009, 2010 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 24 "vhd2vl.y"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <assert.h>
#include "def.h"

int yylex(void);
void yyerror(const char *s);

int vlog_ver=0;  /* default is -g1995 */

/* You will of course want to tinker with this if you use a debugging
 * malloc(), otherwise all the line numbers will point here.
 */
void *xmalloc(size_t size) {
	void *p = malloc(size);
	if (!p) {
		perror("malloc");
		exit(2);
	}
	return p;
}

int skipRem = 0;
int lineno=1;

sglist *io_list=NULL;
sglist *sig_list=NULL;
sglist *type_list=NULL;
blknamelist *blkname_list=NULL;

/* need a stack of clock-edges because all edges are processed before all processes are processed.
 * Edges are processed in source file order, processes are processed in reverse source file order.
 * The original scheme of just one clkedge variable makes all clocked processes have the edge sensitivity
 * of the last clocked process in the file.
 */
int clkedges[MAXEDGES];
int clkptr = 0;
int delay=1;
int dolist=1;
int np=1;
char wire[]="wire";
char reg[]="reg";
int dowith=0;
slist *slwith;

/* Indentation variables */
int indent=0;
slist *indents[MAXINDENT];

struct vrange *new_vrange(enum vrangeType t)
{
  struct vrange *v=xmalloc(sizeof(vrange));
  v->vtype=t;
  v->nlo = NULL;
  v->nhi = NULL;
  v->size_expr = NULL;
  v->sizeval = 0;
  v->xlo = NULL;
  v->xhi = NULL;
  return v;
}

void fslprint(FILE *fp,slist *sl){
  if(sl){
    assert(sl != sl->slst);
    fslprint(fp,sl->slst);
    switch(sl->type){
    case 0 :
      assert(sl != sl->data.sl);
      fslprint(fp,sl->data.sl);
      break;
    case 1 : case 4 :
      fprintf(fp,"%s",sl->data.txt);
      break;
    case 2 :
      fprintf(fp,"%d",sl->data.val);
      break;
    case 3 :
      fprintf(fp,"%s",*(sl->data.ptxt));
      break;
    }
  }
}

void slprint(slist *sl){
  fslprint(stdout, sl);
}

slist *copysl(slist *sl){
  if(sl){
    slist *newsl;
    newsl = xmalloc(sizeof(slist));
    *newsl = *sl;
    if (sl->slst != NULL) {
      assert(sl != sl->slst);
      newsl->slst = copysl(sl->slst);
    }
    switch(sl->type){
    case 0 :
      if (sl->data.sl != NULL) {
        assert(sl != sl->data.sl);
        newsl->data.sl = copysl(sl->data.sl);
      }
      break;
    case 1 : case 4 :
      newsl->data.txt = xmalloc(strlen(sl->data.txt) + 1);
      strcpy(newsl->data.txt, sl->data.txt);
      break;
    }
    return newsl;
  }
  return NULL;
}

slist *addtxt(slist *sl, const char *s){
  slist *p;

  if(s == NULL)
    return sl;
  p = xmalloc(sizeof *p);
  p->type = 1;
  p->slst = sl;
  p->data.txt = xmalloc(strlen(s) + 1);
  strcpy(p->data.txt, s);

  return p;
}

slist *addothers(slist *sl, char *s){
  slist *p;

  if(s == NULL)
    return sl;
  p = xmalloc(sizeof *p);
  p->type = 4;
  p->slst = sl;
  p->data.txt = xmalloc(strlen(s) + 1);
  strcpy(p->data.txt, s);

  return p;
}

slist *addptxt(slist *sl, char **s){
  slist *p;

  if(s == NULL)
    return sl;

  p = xmalloc(sizeof *p);
  p->type = 3;
  p->slst = sl;
  p->data.ptxt = s;

  return p;
}

slist *addval(slist *sl, int val){
  slist *p;

  p = xmalloc(sizeof(slist));
  p->type = 2;
  p->slst = sl;
  p->data.val = val;

  return p;
}

slist *addsl(slist *sl, slist *sl2){
  slist *p;
  if(sl2 == NULL) return sl;
  p = xmalloc(sizeof(slist));
  p->type = 0;
  p->slst = sl;
  p->data.sl = sl2;
  return p;
}

slist *addvec(slist *sl, char *s){
  sl=addval(sl,strlen(s));
  sl=addtxt(sl,"'b ");
  sl=addtxt(sl,s);
  return sl;
}

slist *addvec_base(slist *sl, char *b, char *s){
  const char *base_str="'b ";
  int base_mult=1;
  if (strcasecmp(b,"X") == 0) {
     base_str="'h "; base_mult=4;
  } else if (strcasecmp(b,"O") == 0) {
     base_str="'o "; base_mult=3;
  } else {
     fprintf(stderr,"Warning on line %d: NAME STRING rule matched but "
       "NAME='%s' is not X or O.\n",lineno, b);
  }
  sl=addval(sl,strlen(s)*base_mult);
  sl=addtxt(sl,base_str);
  sl=addtxt(sl,s);
  return sl;
}

slist *addind(slist *sl){
  if(sl)
    sl=addsl(indents[indent],sl);
  return sl;
}

slist *addpar(slist *sl, vrange *v){
  if(v->nlo != NULL) {   /* indexes are simple expressions */
    sl=addtxt(sl," [");
    if(v->nhi != NULL){
      sl=addsl(sl,v->nhi);
      sl=addtxt(sl,":");
    }
    sl=addsl(sl,v->nlo);
    sl=addtxt(sl,"] ");
  } else {
    sl=addtxt(sl," ");
  }
  return sl;
}

slist *addpar_snug(slist *sl, vrange *v){
  if(v->nlo != NULL) {   /* indexes are simple expressions */
    sl=addtxt(sl,"[");
    if(v->nhi != NULL){
      sl=addsl(sl,v->nhi);
      sl=addtxt(sl,":");
    }
    sl=addsl(sl,v->nlo);
    sl=addtxt(sl,"]");
  }
  return sl;
}

/* This function handles array of vectors in signal lists */
slist *addpar_snug2(slist *sl, vrange *v, vrange *v1){
  if(v->nlo != NULL) {   /* indexes are simple expressions */
    sl=addtxt(sl,"[");
    if(v->nhi != NULL){
      sl=addsl(sl,v->nhi);
      sl=addtxt(sl,":");
    }
    sl=addsl(sl,v->nlo);
    sl=addtxt(sl,"]");
  }
  if(v1->nlo != NULL) {   /* indexes are simple expressions */
    sl=addtxt(sl,"[");
    if(v1->nhi != NULL){
      sl=addsl(sl,v1->nhi);
      sl=addtxt(sl,":");
    }
    sl=addsl(sl,v1->nlo);
    sl=addtxt(sl,"]");
  }
  return sl;
}

slist *addpost(slist *sl, vrange *v){
  if(v->xlo != NULL) {
    sl=addtxt(sl,"[");
    if(v->xhi != NULL){
      sl=addsl(sl,v->xhi);
      sl=addtxt(sl,":");
    }
    sl=addsl(sl,v->xlo);
    sl=addtxt(sl,"]");
  }
  return sl;
}

slist *addwrap(const char *l,slist *sl,const char *r){
slist *s;
  s=addtxt(NULL,l);
  s=addsl(s,sl);
  return addtxt(s,r);
}

expdata *addnest(struct expdata *inner)
{
  expdata *e;
  e=xmalloc(sizeof(expdata));
  if (inner->op == 'c') {
    e->sl=addwrap("{",inner->sl,"}");
  } else {
    e->sl=addwrap("(",inner->sl,")");
  }
  return e;
}

slist *addrem(slist *sl, slist *rem)
{
  if (rem) {
    sl=addtxt(sl, "  ");
    sl=addsl(sl, rem);
  } else {
    sl=addtxt(sl, "\n");
  }
  return sl;
}

sglist *lookup(sglist *sg,char *s){
  for(;;){
    if(sg == NULL || strcmp(sg->name,s)==0)
      return sg;
    sg=sg->next;
  }
}

char *sbottom(slist *sl){
  while(sl->slst != NULL)
    sl=sl->slst;
  return sl->data.txt;
}

const char *inout_string(int type)
{
  const char *name=NULL;
  switch(type) {
    case 0: name="input"  ; break;
    case 1: name="output" ; break;
    case 2: name="inout"  ; break;
    default: break;
  }
  return name;
}

int prec(int op){
  switch(op){
  case 'o': /* others */
    return 9;
    break;
  case 't':case 'n':
    return 8;
    break;
  case '~':
    return 7;
    break;
  case 'p': case 'm':
    return 6;
    break;
  case '*': case '/': case '%':
    return 5;
    break;
  case '+': case '-':
    return 4;
    break;
  case '&':
    return 3;
    break;
  case '^':
    return 2;
    break;
  case '|':
    return 1;
    break;
   default:
    return 0;
    break;
  }
}

expdata *addexpr(expdata *expr1,int op,const char* opstr,expdata *expr2){
slist *sl1,*sl2;
  if(expr1 == NULL)
    sl1=NULL;
  else if(expr1->op == 'c')
    sl1=addwrap("{",expr1->sl,"}");
  else if(prec(expr1->op) < prec(op))
    sl1=addwrap("(",expr1->sl,")");
  else
    sl1=expr1->sl;

  if(expr2->op == 'c')
    sl2=addwrap("{",expr2->sl,"}");
  else if(prec(expr2->op) < prec(op))
    sl2=addwrap("(",expr2->sl,")");
  else
    sl2=expr2->sl;

  if(expr1 == NULL)
    expr1=expr2;
  else
    free(expr2);

  expr1->op=op;
  sl1=addtxt(sl1,opstr);
  sl1=addsl(sl1,sl2);
  expr1->sl=sl1;
  return expr1;
}

void slTxtReplace(slist *sl, const char *match, const char *replace){
  if(sl){
    slTxtReplace(sl->slst, match, replace);
    switch(sl->type) {
    case 0 :
      slTxtReplace(sl->data.sl, match, replace);
      break;
    case 1 :
      if (strcmp(sl->data.txt, match) == 0) {
        sl->data.txt = strdup(replace);
      }
      break;
    case 3 :
      if (strcmp(*(sl->data.ptxt), match) == 0) {
        *(sl->data.ptxt) = strdup(replace);
      }
      break;
    }
  }
}


/* XXX todo: runtime engage clkedge debug */
void push_clkedge(int val, const char *comment)
{
  if (0) fprintf(stderr,"clock event push: line=%d clkptr=%d, value=%d (%s)\n",lineno,clkptr,val,comment);
  clkedges[clkptr++]=val;
  assert(clkptr < MAXEDGES);
}

int pull_clkedge(slist *sensitivities)
{
  int clkedge;
  assert(clkptr>0);
  clkedge = clkedges[--clkptr];
  if (0) {
     fprintf(stderr,"clock event pull: value=%d, sensistivity list = ", clkedge);
     fslprint(stderr,sensitivities);
     fprintf(stderr,"\n");
  }
  return clkedge;
}

/* XXX maybe it's a bug that some uses don't munge clocks? */
slist *add_always(slist *sl, slist *sensitivities, slist *decls, int munge)
{
           int clkedge;
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"always @(");
           if (munge) {
             clkedge = pull_clkedge(sensitivities);
             if(clkedge) {
               sl=addtxt(sl,"posedge ");
               /* traverse $4->sl replacing " or " with " or posedge " if there is a clockedge */
               slTxtReplace(sensitivities," or ", " or posedge ");
             } else {
               sl=addtxt(sl,"negedge ");
               slTxtReplace(sensitivities," or ", " or negedge ");
             }
           }
           sl=addsl(sl,sensitivities);
           sl=addtxt(sl,") begin");
           if(decls){
             sl=addtxt(sl," : P");
             sl=addval(sl,np++);
             sl=addtxt(sl,"\n");
             sl=addsl(sl,decls);
           }
           sl=addtxt(sl,"\n");
           return sl;
}

void fixothers(slist *size_expr, slist *sl) {
  if(sl) {
    fixothers(size_expr, sl->slst);
    switch(sl->type) {
    case 0 :
      fixothers(size_expr,sl->data.sl);
      break;
    case 4 : {
      /* found an (OTHERS => 'x') clause - change to type 0, and insert the
       * size_expr for the corresponding signal */
      slist *p;
      slist *size_copy = xmalloc(sizeof(slist));
      size_copy = copysl(size_expr);
      if (0) {
        fprintf(stderr,"fixothers type 4 size_expr ");
        fslprint(stderr,size_expr);
        fprintf(stderr,"\n");
      }
      p = addtxt(NULL, "1'b");
      p = addtxt(p, sl->data.txt);
      p = addwrap("{",p,"}");
      p = addsl(size_copy, p);
      p = addwrap("{",p,"}");
      sl->type=0;
      sl->slst=p;
      sl->data.sl=NULL;
      break;
    } /* case 4 */
    } /* switch */
  }
}

void findothers(slval *sgin,slist *sl){
  sglist *sg = NULL;
  int size = -1;
  int useExpr=0;
  if (0) {
    fprintf(stderr,"findothers lhs ");
    fslprint(stderr,sgin->sl);
    fprintf(stderr,", sgin->val %d\n", sgin->val);
  }
  if(sgin->val>0) {
    size=sgin->val;
  } else if (sgin->range != NULL) {
    if (sgin->range->vtype != tVRANGE) {
      size=1;
    } else if (sgin->range->sizeval > 0) {
      size=sgin->range->sizeval;
    } else if (sgin->range->size_expr != NULL) {
      useExpr = 1;
      fixothers(sgin->range->size_expr, sl);
    }
  } else {
    if((sg=lookup(io_list,sgin->sl->data.txt))==NULL) {
      sg=lookup(sig_list,sgin->sl->data.txt);
    }
    if(sg) {
      if(sg->range->vtype != tVRANGE) {
        size=1;
      } else {
        if (sg->range->sizeval > 0) {
          size = sg->range->sizeval;
        } else {
          assert (sg->range->size_expr != NULL);
          useExpr = 1;
          fixothers(sg->range->size_expr, sl);
        }
      }
    } else {
      /* lookup failed, there was no vrange or size value in sgin - so just punt, and assign size=1 */
      size=1;
    }  /* if(sg) */
  }
  if (!useExpr) {
    slist *p;
    assert(size>0);
    /* use size */
    p = addval(NULL,size);
    fixothers(p,sl);
  }
}

/* code to find bit number of the msb of n */
int find_msb(int n)
{
    int k=0;
    if(n&0xff00){
        k|=8;
        n&=0xff00;
    }
    if(n&0xf0f0){
        k|=4;
        n&=0xf0f0;
    }
    if(n&0xcccc){
        k|=2;
        n&=0xcccc;
    }
    if(n&0xaaaa){
        k|=1;
        n&=0xaaaa;
    }
    return k;
}

static char time_unit[2]="\0\0", new_unit[2]="\0\0";
static void set_timescale(const char *s)
{
    if (0) fprintf(stderr,"set_timescale (%s)\n", s);
    new_unit[0] = time_unit[0];
         if (strcasecmp(s,"ms") == 0) { new_unit[0] = 'm'; }
    else if (strcasecmp(s,"us") == 0) { new_unit[0] = 'u'; }
    else if (strcasecmp(s,"ns") == 0) { new_unit[0] = 'n'; }
    else if (strcasecmp(s,"ps") == 0) { new_unit[0] = 'p'; }
    else {
        fprintf(stderr,"Warning on line %d: AFTER NATURAL NAME pattern"
               " matched, but NAME='%s' should be a time unit.\n",lineno,s);
    }
    if (new_unit[0] != time_unit[0]) {
        if (time_unit[0] != 0) {
            fprintf(stderr,"Warning on line %d: inconsistent time unit (%s) ignored\n", lineno, s);
        } else {
            time_unit[0] = new_unit[0];
        }
    }
}

slist *output_timescale(slist *sl)
{
    if (time_unit[0] != 0) {
        sl = addtxt(sl, "`timescale 1 ");
        sl = addtxt(sl, time_unit);
        sl = addtxt(sl, "s / 1 ");
        sl = addtxt(sl, time_unit);
        sl = addtxt(sl, "s\n");
    } else {
        sl = addtxt(sl, "// no timescale needed\n");
    }
    return sl;
}

slist *setup_port(sglist *s_list, int dir, vrange *type) {
  slist *sl;
  sglist *p;
  if (vlog_ver == 1) {
    sl=addtxt(NULL,NULL);
  }
  else {
    sl=addtxt(NULL,inout_string(dir));
    sl=addpar(sl,type);
  }
  p=s_list;
  for(;;){
    p->type=wire;
    if (vlog_ver == 1) p->dir=inout_string(dir);
    p->range=type;
    if (vlog_ver == 0) sl=addtxt(sl, p->name);
    if(p->next==NULL)
      break;
    p=p->next;
    if (vlog_ver == 0) sl=addtxt(sl,", ");
  }
  if (vlog_ver == 0) sl=addtxt(sl,";\n");
  p->next=io_list;
  io_list=s_list;
  return sl;
}

slist *emit_io_list(slist *sl)
{
              sglist *p;
              sl=addtxt(sl,"(\n");
              p=io_list;
              for(;;){
                if (vlog_ver == 1) {
                  sl=addtxt(sl,p->dir);
                  sl=addtxt(sl," ");
                  sl=addptxt(sl,&(p->type));
                  sl=addpar(sl,p->range);
                }
                sl=addtxt(sl,p->name);
                p=p->next;
                if(p)
                  sl=addtxt(sl,",\n");
                else{
                  sl=addtxt(sl,"\n");
                  break;
                }
              }
              sl=addtxt(sl,");\n\n");
              return sl;
}


/* Line 189 of yacc.c  */
#line 734 "vhd2vl.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     REM = 258,
     ENTITY = 259,
     IS = 260,
     PORT = 261,
     GENERIC = 262,
     IN = 263,
     OUT = 264,
     INOUT = 265,
     MAP = 266,
     INTEGER = 267,
     BIT = 268,
     BITVECT = 269,
     DOWNTO = 270,
     TO = 271,
     TYPE = 272,
     END = 273,
     ARCHITECTURE = 274,
     COMPONENT = 275,
     OF = 276,
     ARRAY = 277,
     SIGNAL = 278,
     BEGN = 279,
     NOT = 280,
     WHEN = 281,
     WITH = 282,
     EXIT = 283,
     SELECT = 284,
     OTHERS = 285,
     PROCESS = 286,
     VARIABLE = 287,
     CONSTANT = 288,
     IF = 289,
     THEN = 290,
     ELSIF = 291,
     ELSE = 292,
     CASE = 293,
     FOR = 294,
     LOOP = 295,
     GENERATE = 296,
     AFTER = 297,
     AND = 298,
     OR = 299,
     XOR = 300,
     MOD = 301,
     LASTVALUE = 302,
     EVENT = 303,
     POSEDGE = 304,
     NEGEDGE = 305,
     STRING = 306,
     NAME = 307,
     RANGE = 308,
     NULLV = 309,
     OPEN = 310,
     CONVFUNC_1 = 311,
     CONVFUNC_2 = 312,
     BASED = 313,
     FLOAT = 314,
     NATURAL = 315,
     ORL = 316,
     ANDL = 317,
     XNOR = 318,
     EQUAL = 319,
     NOTEQ = 320,
     LESSEQ = 321,
     BIGEQ = 322,
     NOTL = 323,
     UPLUS = 324,
     UMINUS = 325
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 685 "vhd2vl.y"

  char * txt; /* String */
  int n;      /* Value */
  vrange *v;  /* Signal range */
  sglist *sg; /* Signal list */
  slist *sl;  /* String list */
  expdata *e; /* Expression structure */
  slval *ss;  /* Signal structure */



/* Line 214 of yacc.c  */
#line 852 "vhd2vl.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 864 "vhd2vl.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  6
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1199

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  86
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  55
/* YYNRULES -- Number of rules.  */
#define YYNRULES  180
/* YYNRULES -- Number of states.  */
#define YYNSTATES  647

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   325

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    73,    83,
      79,    80,    74,    71,    84,    72,     2,    75,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    82,    81,
      65,    61,    66,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    85,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    62,    63,    64,    67,
      68,    69,    70,    76,    77,    78
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     9,    13,    17,    18,    20,    22,    25,
      26,    28,    29,    31,    32,    34,    35,    37,    40,    43,
      44,    45,    61,    85,    93,   103,   110,   115,   121,   129,
     138,   149,   151,   153,   155,   157,   163,   165,   170,   172,
     176,   178,   182,   184,   186,   202,   203,   204,   205,   213,
     224,   235,   245,   258,   279,   280,   289,   290,   291,   294,
     299,   301,   311,   325,   337,   353,   375,   392,   416,   448,
     484,   496,   512,   528,   529,   531,   533,   537,   539,   543,
     547,   553,   559,   564,   569,   570,   573,   578,   584,   589,
     591,   599,   610,   612,   622,   631,   644,   660,   676,   687,
     692,   697,   698,   706,   711,   720,   728,   729,   731,   735,
     737,   740,   742,   744,   748,   752,   758,   766,   767,   768,
     772,   775,   780,   782,   787,   789,   791,   793,   796,   798,
     805,   808,   813,   816,   821,   823,   828,   836,   838,   840,
     842,   844,   847,   850,   857,   861,   864,   867,   871,   875,
     879,   883,   887,   890,   894,   898,   902,   906,   911,   918,
     925,   929,   931,   935,   939,   943,   946,   950,   954,   959,
     963,   968,   973,   975,   977,   979,   983,   987,   991,   995,
    1000
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
      87,     0,    -1,    88,    98,    88,   105,    88,    -1,    88,
      98,    88,    -1,    88,   105,    88,    -1,    -1,    89,    -1,
       3,    -1,     3,    89,    -1,    -1,     5,    -1,    -1,     4,
      -1,    -1,    19,    -1,    -1,    24,    -1,    41,    93,    -1,
      18,    41,    -1,    -1,    -1,     4,    52,     5,    88,     6,
      79,    88,   100,    80,    81,    88,    18,    91,   114,    81,
      -1,     4,    52,     5,     7,   111,    79,    88,    99,    80,
      81,    88,     6,   111,    79,    88,   100,    80,    81,    88,
      18,    91,   114,    81,    -1,   112,    82,   102,    82,    61,
     137,    88,    -1,   112,    82,   102,    82,    61,   137,    81,
      88,    99,    -1,   112,    82,   102,    81,    88,    99,    -1,
     112,    82,   102,    88,    -1,   112,    82,   101,   102,    88,
      -1,   112,    82,   101,   102,    81,    88,   100,    -1,   112,
      82,   101,   102,    82,    61,   137,    88,    -1,   112,    82,
     101,   102,    82,    61,   137,    81,    88,   100,    -1,     8,
      -1,     9,    -1,    10,    -1,    13,    -1,    12,    53,   137,
      16,   137,    -1,    12,    -1,    14,    79,   103,    80,    -1,
      52,    -1,   140,   104,   140,    -1,   140,    -1,    52,    83,
      53,    -1,    15,    -1,    16,    -1,    19,    52,    21,    52,
       5,    88,   108,    24,   106,   113,    18,    92,   114,    81,
     107,    -1,    -1,    -1,    -1,   108,    23,   112,    82,   102,
      81,    88,    -1,   108,    23,   112,    82,   102,    82,    61,
     137,    81,    88,    -1,   108,    33,    52,    82,   102,    82,
      61,   137,    81,    88,    -1,   108,    17,    52,     5,    79,
     112,    80,    81,    88,    -1,   108,    17,    52,     5,    22,
      79,   103,    80,    21,   102,    81,    88,    -1,   108,    20,
      52,    90,    88,   109,     6,   110,    79,    88,   100,    80,
      81,    88,    18,    20,   114,    81,   111,    88,    -1,    -1,
       7,   110,    79,    88,    99,    80,    81,    88,    -1,    -1,
      -1,    52,    88,    -1,    52,    84,    88,   112,    -1,    88,
      -1,    88,   136,    65,    61,    88,    96,   128,    97,   113,
      -1,    88,    24,   136,    65,    61,    88,    96,   128,    97,
     113,    18,    52,    81,    -1,    88,    27,   137,    29,    88,
     118,   136,    65,    61,   119,   113,    -1,    88,    52,    82,
      52,    88,     6,    11,    79,   106,   131,    88,    80,    81,
     107,   113,    -1,    88,    52,    82,    52,    88,     7,    11,
      79,   106,   134,    80,   107,     6,    11,    79,   106,   131,
      80,    81,   107,   113,    -1,   115,    31,    79,   127,    80,
     121,    90,    24,   106,   122,    18,    31,   114,    81,   107,
     113,    -1,   115,    31,    79,   127,    80,   121,    90,    24,
     106,    88,    34,   117,    35,   122,    18,    34,    81,    18,
      31,   114,    81,   107,   113,    -1,   115,    31,    79,   127,
      80,   121,    90,    24,   106,    88,    34,   138,    35,   106,
     122,   107,    36,   117,    35,   106,   122,   107,    18,    34,
      81,    18,    31,   114,    81,   107,   113,    -1,   115,    31,
      79,   127,    80,   121,    90,    24,   106,    88,    34,   138,
      35,   106,   122,   107,    37,    34,   117,    35,   106,   122,
     107,    18,    34,    81,    18,    34,    81,    18,    31,   114,
      81,   107,   113,    -1,   116,    34,   138,    94,   106,   113,
     107,    95,   114,    81,   113,    -1,   116,    39,   136,     8,
     137,    16,   137,    94,   106,   113,   107,    95,   114,    81,
     113,    -1,   116,    39,   136,     8,   137,    15,   137,    94,
     106,   113,   107,    95,   114,    81,   113,    -1,    -1,    52,
      -1,    88,    -1,    88,    52,    82,    -1,    88,    -1,    88,
      52,    82,    -1,    79,   117,    80,    -1,    52,    83,    48,
      43,   138,    -1,   138,    43,    52,    83,    48,    -1,    49,
      79,    52,    80,    -1,    50,    79,    52,    80,    -1,    -1,
     120,    81,    -1,   120,    84,    88,   119,    -1,   137,   130,
      26,    30,    81,    -1,   137,   130,    26,   125,    -1,    88,
      -1,    88,    32,   112,    82,   102,    81,   121,    -1,    88,
      32,   112,    82,   102,    82,    61,   137,    81,   121,    -1,
      88,    -1,    88,   136,    82,    61,    96,   137,    81,    97,
     122,    -1,    88,   136,    96,    65,    61,   128,    97,   122,
      -1,    88,    34,   138,    35,   106,   122,   107,   123,    18,
      34,    81,   122,    -1,    88,    39,   136,     8,   137,    16,
     137,    40,   106,   122,   107,    18,    40,    81,   122,    -1,
      88,    39,   136,     8,   137,    15,   137,    40,   106,   122,
     107,    18,    40,    81,   122,    -1,    88,    38,   136,     5,
      88,   124,    18,    38,    81,   122,    -1,    88,    28,    81,
     122,    -1,    88,    54,    81,   122,    -1,    -1,    36,   138,
      35,   106,   122,   107,   123,    -1,    37,   106,   122,   107,
      -1,    26,   125,    61,    66,   106,   122,   107,   124,    -1,
      26,    30,    61,    66,   106,   122,   107,    -1,    -1,   126,
      -1,   125,    85,   126,    -1,    51,    -1,    52,    51,    -1,
      52,    -1,   136,    -1,   136,    84,   127,    -1,   137,   130,
      81,    -1,   137,   130,    26,   138,    81,    -1,   137,   130,
      26,   138,    37,   129,   128,    -1,    -1,    -1,    42,    60,
      52,    -1,    88,   132,    -1,    88,   132,    84,   131,    -1,
     133,    -1,    52,    61,    66,   133,    -1,    51,    -1,   136,
      -1,    60,    -1,    52,    51,    -1,    55,    -1,    79,    30,
      61,    66,    51,    80,    -1,    88,   135,    -1,    88,   135,
      84,   134,    -1,    88,   137,    -1,    52,    61,    66,   137,
      -1,    52,    -1,    52,    79,   103,    80,    -1,    52,    79,
     103,    80,    79,   103,    80,    -1,   136,    -1,    51,    -1,
      59,    -1,    60,    -1,    60,    58,    -1,    52,    51,    -1,
      79,    30,    61,    66,    51,    80,    -1,   137,    73,   137,
      -1,    72,   137,    -1,    71,   137,    -1,   137,    71,   137,
      -1,   137,    72,   137,    -1,   137,    74,   137,    -1,   137,
      75,   137,    -1,   137,    46,   137,    -1,    25,   137,    -1,
     137,    43,   137,    -1,   137,    44,   137,    -1,   137,    45,
     137,    -1,   137,    64,   137,    -1,    14,    79,   137,    80,
      -1,    57,    79,   137,    84,    60,    80,    -1,    57,    79,
     137,    84,    52,    80,    -1,    79,   137,    80,    -1,   139,
      -1,    79,   138,    80,    -1,   138,    43,   138,    -1,   138,
      44,   138,    -1,    25,   138,    -1,   137,    61,   137,    -1,
     137,    66,   137,    -1,   137,    66,    61,   137,    -1,   137,
      65,   137,    -1,   137,    65,    61,   137,    -1,   137,    75,
      61,   137,    -1,   136,    -1,    51,    -1,    60,    -1,   140,
      71,   140,    -1,   140,    72,   140,    -1,   140,    74,   140,
      -1,   140,    75,   140,    -1,    56,    79,   140,    80,    -1,
      79,   140,    80,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   757,   757,   772,   780,   791,   792,   795,   796,   802,
     802,   804,   804,   806,   806,   808,   808,   810,   812,   815,
     816,   820,   847,   878,   899,   921,   941,   962,   975,   988,
    1002,  1017,  1018,  1019,  1022,  1025,  1031,  1036,  1037,  1051,
    1089,  1093,  1108,  1109,  1113,  1123,  1126,  1129,  1130,  1158,
    1188,  1197,  1237,  1250,  1258,  1259,  1267,  1268,  1271,  1284,
    1299,  1301,  1313,  1326,  1354,  1367,  1387,  1396,  1411,  1438,
    1467,  1492,  1531,  1570,  1571,  1574,  1575,  1577,  1578,  1590,
    1591,  1594,  1597,  1600,  1605,  1607,  1608,  1616,  1635,  1656,
    1657,  1677,  1701,  1703,  1717,  1736,  1749,  1771,  1793,  1808,
    1814,  1824,  1825,  1835,  1844,  1853,  1860,  1863,  1864,  1871,
    1872,  1873,  1876,  1877,  1885,  1901,  1905,  1918,  1921,  1922,
    1928,  1932,  1941,  1942,  1952,  1953,  1954,  1955,  1956,  1957,
    1966,  1970,  1977,  1982,  1992,  2006,  2030,  2052,  2060,  2067,
    2073,  2079,  2104,  2110,  2117,  2126,  2127,  2128,  2129,  2130,
    2131,  2132,  2133,  2134,  2135,  2136,  2137,  2138,  2149,  2153,
    2156,  2162,  2163,  2166,  2171,  2176,  2184,  2201,  2218,  2235,
    2252,  2269,  2288,  2296,  2303,  2311,  2314,  2317,  2320,  2323,
    2330
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "REM", "ENTITY", "IS", "PORT", "GENERIC",
  "IN", "OUT", "INOUT", "MAP", "INTEGER", "BIT", "BITVECT", "DOWNTO", "TO",
  "TYPE", "END", "ARCHITECTURE", "COMPONENT", "OF", "ARRAY", "SIGNAL",
  "BEGN", "NOT", "WHEN", "WITH", "EXIT", "SELECT", "OTHERS", "PROCESS",
  "VARIABLE", "CONSTANT", "IF", "THEN", "ELSIF", "ELSE", "CASE", "FOR",
  "LOOP", "GENERATE", "AFTER", "AND", "OR", "XOR", "MOD", "LASTVALUE",
  "EVENT", "POSEDGE", "NEGEDGE", "STRING", "NAME", "RANGE", "NULLV",
  "OPEN", "CONVFUNC_1", "CONVFUNC_2", "BASED", "FLOAT", "NATURAL", "'='",
  "ORL", "ANDL", "XNOR", "'<'", "'>'", "EQUAL", "NOTEQ", "LESSEQ", "BIGEQ",
  "'+'", "'-'", "'&'", "'*'", "'/'", "NOTL", "UPLUS", "UMINUS", "'('",
  "')'", "';'", "':'", "'\\''", "','", "'|'", "$accept", "trad", "rem",
  "remlist", "opt_is", "opt_entity", "opt_architecture", "opt_begin",
  "generate", "endgenerate", "norem", "yesrem", "entity", "genlist",
  "portlist", "dir", "type", "vec_range", "updown", "architecture",
  "doindent", "unindent", "a_decl", "opt_generic", "nolist", "yeslist",
  "s_list", "a_body", "oname", "optname", "gen_optname", "edge", "yeswith",
  "with_list", "with_item", "p_decl", "p_body", "elsepart", "cases",
  "wlist", "wvalue", "sign_list", "sigvalue", "nodelay", "delay",
  "map_list", "map_item", "mvalue", "generic_map_list", "generic_map_item",
  "signal", "expr", "exprc", "conf", "simple_expr", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    61,   316,   317,   318,    60,    62,   319,   320,   321,
     322,    43,    45,    38,    42,    47,   323,   324,   325,    40,
      41,    59,    58,    39,    44,   124
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    86,    87,    87,    87,    88,    88,    89,    89,    90,
      90,    91,    91,    92,    92,    93,    93,    94,    95,    96,
      97,    98,    98,    99,    99,    99,    99,   100,   100,   100,
     100,   101,   101,   101,   102,   102,   102,   102,   102,   103,
     103,   103,   104,   104,   105,   106,   107,   108,   108,   108,
     108,   108,   108,   108,   109,   109,   110,   111,   112,   112,
     113,   113,   113,   113,   113,   113,   113,   113,   113,   113,
     113,   113,   113,   114,   114,   115,   115,   116,   116,   117,
     117,   117,   117,   117,   118,   119,   119,   119,   120,   121,
     121,   121,   122,   122,   122,   122,   122,   122,   122,   122,
     122,   123,   123,   123,   124,   124,   124,   125,   125,   126,
     126,   126,   127,   127,   128,   128,   128,   129,   130,   130,
     131,   131,   132,   132,   133,   133,   133,   133,   133,   133,
     134,   134,   134,   135,   136,   136,   136,   137,   137,   137,
     137,   137,   137,   137,   137,   137,   137,   137,   137,   137,
     137,   137,   137,   137,   137,   137,   137,   137,   137,   137,
     137,   138,   138,   138,   138,   138,   139,   139,   139,   139,
     139,   139,   140,   140,   140,   140,   140,   140,   140,   140,
     140
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     5,     3,     3,     0,     1,     1,     2,     0,
       1,     0,     1,     0,     1,     0,     1,     2,     2,     0,
       0,    15,    23,     7,     9,     6,     4,     5,     7,     8,
      10,     1,     1,     1,     1,     5,     1,     4,     1,     3,
       1,     3,     1,     1,    15,     0,     0,     0,     7,    10,
      10,     9,    12,    20,     0,     8,     0,     0,     2,     4,
       1,     9,    13,    11,    15,    21,    16,    23,    31,    35,
      11,    15,    15,     0,     1,     1,     3,     1,     3,     3,
       5,     5,     4,     4,     0,     2,     4,     5,     4,     1,
       7,    10,     1,     9,     8,    12,    15,    15,    10,     4,
       4,     0,     7,     4,     8,     7,     0,     1,     3,     1,
       2,     1,     1,     3,     3,     5,     7,     0,     0,     3,
       2,     4,     1,     4,     1,     1,     1,     2,     1,     6,
       2,     4,     2,     4,     1,     4,     7,     1,     1,     1,
       1,     2,     2,     6,     3,     2,     2,     3,     3,     3,
       3,     3,     2,     3,     3,     3,     3,     4,     6,     6,
       3,     1,     3,     3,     3,     2,     3,     3,     4,     3,
       4,     4,     1,     1,     1,     3,     3,     3,     3,     4,
       3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       5,     7,     0,     0,     6,     8,     1,     0,     0,     5,
       5,     0,     0,     3,     4,     5,     0,     5,    57,     0,
       0,     2,     0,     0,     5,     5,     5,    47,     0,     0,
       0,     5,     0,     0,     0,     0,     0,     0,     0,    45,
       0,     5,    58,     0,     0,     0,     0,     0,     9,     0,
       5,     0,     0,     5,    36,    34,     0,    38,     5,     5,
      31,    32,    33,     0,     0,    10,     5,     0,    77,     0,
       0,     0,     0,    59,     0,     0,     0,     5,     0,    26,
       0,     5,     0,     0,    54,     0,     0,     0,   134,     0,
      13,     0,     0,     0,     0,    57,     0,     0,   138,   134,
       0,   139,   140,     0,     0,     0,   137,     0,   173,   134,
       0,   174,     0,     0,   172,    40,     0,     0,    11,     5,
       0,    27,     0,     0,    56,     0,     5,     0,   134,     0,
       0,     0,    78,     0,    14,    73,     0,     0,     0,     0,
       0,   161,     0,     0,     0,     0,   152,   142,     0,   141,
     146,   145,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    37,    42,
      43,     0,     0,     0,     0,     0,    25,     5,    12,    73,
       0,     0,     0,     0,     0,    56,    48,     0,     0,     5,
       0,     5,     5,    74,     0,     0,   112,   152,   165,     0,
       0,     0,     0,     0,     0,    15,     0,     0,    45,     0,
       0,     5,     0,     0,     0,   160,    35,   153,   154,   155,
     151,   156,   147,   148,   144,   149,   150,    41,     0,   180,
     175,   176,   177,   178,    39,     5,    23,     0,    28,     5,
       0,     5,     5,     0,     0,     5,    84,   135,     0,    19,
      46,     5,     0,   162,   166,     0,   169,     0,   167,     0,
      16,    17,   163,   164,     5,     0,     0,     0,   157,     0,
       0,   179,     0,    21,     5,    29,     0,    51,     0,     5,
       5,    19,     0,     0,     0,     0,     0,    44,    89,     9,
     113,   170,   168,   171,    46,     0,     0,     5,     0,     0,
       0,     0,    24,     0,     0,     0,     0,    49,     0,     0,
       0,     0,     0,    20,   118,     0,     0,     0,     0,     0,
      50,     0,   159,   158,   143,    30,     5,     0,     0,    20,
       0,   136,    45,    45,     5,     0,     0,     0,    45,     0,
      73,    45,    45,     5,    52,     5,     0,     5,     0,     5,
       5,    61,     0,     0,   114,     0,     5,    18,     0,     5,
       5,     0,    55,     5,     0,     5,     0,   118,     0,     5,
       0,     0,   119,     0,     0,    92,     0,     5,    46,    46,
      11,     0,     0,    63,    85,     5,     0,   124,   134,   128,
     126,     0,   120,   122,   125,     0,   134,   130,   132,    46,
     117,   115,     5,     0,     0,     0,     0,     0,     0,    19,
       0,    70,     0,     0,    73,     0,     0,     0,     0,   127,
       0,     0,     5,     0,     0,     5,     0,     0,    90,     0,
       5,     0,     0,   134,     0,     0,     0,     0,     0,     5,
       0,     0,    73,    73,    73,     0,    73,    62,    86,     0,
     109,   111,    88,   107,     0,     0,   121,    46,     0,   131,
       0,   116,     0,    92,    99,     0,     0,     0,     0,     0,
       5,    45,     0,     5,     0,   100,    19,     0,     0,     0,
       0,    22,     0,    87,   110,     0,   134,   123,     0,     5,
     133,     0,     5,     0,     0,     0,     0,    79,     0,     5,
     134,   106,     0,     0,     0,    46,     5,     5,    57,   108,
       0,    64,    45,    91,     0,    82,    83,     0,     0,    46,
       0,     0,     0,     0,     0,     0,    20,     5,    72,    71,
       5,   129,     5,    45,    80,     0,   101,    81,     0,     0,
       0,     0,     0,    20,     5,    66,    53,     0,     5,     0,
       0,    45,     0,     0,     0,     0,    45,    45,     5,    94,
       0,    46,     0,     0,     0,     0,     5,     0,    45,    45,
       5,     5,     5,    93,    46,   101,    73,    45,    45,     0,
       0,    46,     0,     5,     5,    98,    46,    46,     5,     0,
      45,     0,     5,     5,    45,   103,     5,    46,    46,     0,
       0,    65,     0,    46,    46,    46,     5,    95,   105,   106,
       0,     0,     5,     0,   101,    46,   104,     0,     0,    67,
       0,   102,     0,     5,     5,     0,     0,    97,    96,     0,
       0,     0,     0,    73,     0,     0,     0,    46,     0,     5,
       0,    68,    73,     0,    46,     5,    69
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,   463,     4,    66,   179,   135,   261,   208,   340,
     286,   334,     9,    32,    34,    63,    58,   113,   175,    10,
     566,   287,    30,   125,   184,    22,    35,    69,   194,    70,
      71,   435,   282,   365,   366,   289,   376,   552,   522,   452,
     453,   195,   313,   427,   336,   369,   392,   393,   371,   397,
     106,   139,   262,   141,   115
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -433
static const yytype_int16 yypact[] =
{
      40,    40,    80,    29,  -433,  -433,  -433,     3,    43,    40,
      40,   104,   111,   157,  -433,    93,   138,    40,  -433,   194,
     208,  -433,   145,   153,    40,    40,    40,  -433,   165,   165,
     313,    19,   160,   152,   179,   184,   218,   240,   165,  -433,
     242,    40,  -433,   215,    32,   244,   268,   323,   326,   253,
      40,   262,   165,    40,   300,  -433,   283,  -433,    31,    40,
    -433,  -433,  -433,    32,     7,  -433,    40,    32,    47,   350,
     358,    30,    32,  -433,   391,   764,   154,    40,   338,  -433,
     382,    33,   322,   165,   396,    57,   352,   764,    58,   343,
     394,   331,   812,   352,   336,  -433,   340,   764,  -433,    -9,
     341,  -433,   365,   764,   764,   632,  -433,   624,  -433,    48,
     345,  -433,   202,   346,  -433,   148,   165,   764,   423,    40,
     367,  -433,   154,   349,  -433,   432,    40,   381,   360,   380,
     785,   154,   173,   385,  -433,   395,   352,   812,   700,  1107,
     144,  -433,   440,   389,   372,   764,  -433,  -433,   764,  -433,
    -433,  -433,   398,   999,   764,   764,   764,   764,   764,   764,
     764,   764,   764,   764,   764,   399,   202,   386,  -433,  -433,
    -433,   202,   202,   202,   202,   202,  -433,   122,  -433,   395,
     165,   764,   387,   393,   397,  -433,  -433,   764,   404,    40,
     388,    40,    40,  -433,   405,   390,   401,  -433,  -433,   987,
      13,   764,   315,   723,   748,   448,   812,   812,  -433,   764,
     764,    40,  1011,   897,   409,  -433,  1119,   175,  1124,   309,
     532,   156,    70,    70,    70,  -433,  -433,  -433,   481,  -433,
     181,   181,  -433,  -433,   267,    40,  -433,   406,  -433,   241,
     456,    40,    40,   411,   919,    40,  -433,   412,   230,  -433,
    -433,    40,   352,  -433,   109,   764,   109,   764,   109,   764,
    -433,  -433,   245,   245,    40,   438,   931,   165,  -433,    42,
     429,  -433,   165,  -433,    40,  -433,    32,  -433,   165,    40,
      40,  -433,   352,   154,   477,   482,   764,  -433,   462,   326,
    -433,   109,   109,   109,  -433,   764,   764,    40,   415,   417,
     418,   420,  -433,   165,   424,   434,   165,  -433,   764,   436,
     435,   425,   437,  -433,  1085,   165,   495,   502,  1073,  1073,
    -433,   447,  -433,  -433,  -433,  -433,    40,   452,   441,  -433,
     468,  -433,  -433,  -433,    40,   476,     4,   455,  -433,   499,
     395,  -433,  -433,    40,  -433,    40,   460,    40,   764,    40,
      40,  -433,   490,   812,  -433,    32,    40,  -433,   465,    40,
      40,   529,  -433,    40,   530,    40,   131,  1085,    96,    40,
     837,   471,  -433,    -5,   209,   378,   536,    40,  -433,  -433,
     423,   539,   510,  -433,  -433,    40,   538,  -433,    55,  -433,
    -433,   537,   484,  -433,  -433,   491,   147,   486,  1119,  -433,
    -433,  -433,    40,   513,   506,   384,   352,   352,   508,   509,
     541,  -433,   502,   502,   395,   570,   514,   764,    53,  -433,
     528,   535,    40,   516,   534,    40,   605,   764,  -433,   764,
      40,   540,   542,   -16,   622,   578,   127,   609,   610,    40,
     559,   561,   395,   395,   395,   547,   395,  -433,  -433,   548,
    -433,   582,   549,  -433,   272,   569,  -433,  -433,   764,  -433,
     626,  -433,   943,   511,  -433,   586,   589,   594,   563,    17,
      40,  -433,   860,    40,   764,  -433,  -433,   583,   567,   572,
     573,  -433,   574,  -433,  -433,   259,    -4,  -433,   599,    40,
    1119,   579,    40,   812,   571,   580,   616,  -433,   645,    40,
      41,   638,   883,   764,   764,  -433,    40,    40,  -433,  -433,
     585,  -433,  -433,  -433,   217,  -433,  -433,   812,   641,  -433,
     618,    98,   659,   764,   764,   965,  -433,    40,  -433,  -433,
      40,  -433,    40,  -433,   245,   604,   284,  -433,   625,   -12,
     649,  1049,  1061,  -433,    40,  -433,  -433,   620,    40,   672,
     384,   668,   687,   642,   643,   631,  -433,  -433,    40,  -433,
     634,  -433,   682,   683,   258,   384,    40,   685,  -433,  -433,
      40,    40,    40,  -433,  -433,   321,   395,  -433,  -433,   686,
     327,  -433,   646,    40,    40,  -433,  -433,  -433,    40,   812,
    -433,   650,    40,    40,  -433,  -433,    40,  -433,  -433,   704,
     705,  -433,   274,  -433,  -433,  -433,    40,  -433,  -433,   638,
     684,   695,    40,   708,   321,  -433,  -433,   655,   657,  -433,
     706,  -433,   721,    40,    40,   660,   709,  -433,  -433,   724,
     663,   716,   731,   395,   719,   669,   675,  -433,   743,    40,
     732,  -433,   395,   689,  -433,    40,  -433
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -433,  -433,     0,   763,   478,   407,  -433,  -433,    60,   -17,
    -267,  -325,  -433,  -100,  -160,  -433,   -60,  -104,  -433,   752,
     -34,    12,  -433,  -433,   581,   -94,   -15,  -224,  -171,  -433,
    -433,  -432,  -433,   359,  -433,  -381,   162,   163,   172,   269,
     303,   544,  -297,  -433,   426,  -403,  -433,   344,   376,  -433,
     -14,   421,   -86,  -433,   -84
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -77
static const yytype_int16 yytable[] =
{
       3,   144,   468,    81,   347,    50,   140,    85,   237,    13,
      14,   329,    94,    33,   308,    19,   176,    21,   182,   456,
     238,   428,     1,    49,    27,    28,    29,   190,   167,    82,
     353,    42,   400,     7,     1,   147,     1,    73,   206,   207,
     294,    52,   147,     1,    54,    55,    56,   419,     8,   554,
      68,   198,   200,    74,    89,    11,   206,   207,    79,    80,
     472,   207,   114,   131,    92,   -60,    84,   467,   123,    93,
     131,    86,   129,   485,    87,   131,   401,   116,   -75,   142,
       6,   121,   228,   449,    57,   354,    83,   230,   231,   232,
     233,   234,   147,   253,   299,    12,     1,   253,   114,    88,
      18,    33,   300,    41,   450,   451,   419,   298,   114,    15,
     351,   513,    77,    78,   119,   120,   420,   114,   563,   180,
     131,   263,   196,   364,   520,     1,   186,   131,   538,   547,
     461,   165,    16,   579,   131,   378,   379,   131,   126,   127,
     132,   383,   441,   325,   163,   164,   328,   387,   388,   450,
     451,   389,   114,   411,   157,   158,   390,   114,   114,   114,
     114,   114,   471,   169,   170,   155,   156,   157,   158,   358,
     472,   207,   302,   159,   264,   391,     8,   236,   305,   310,
     160,   161,   162,   163,   164,   205,   159,   206,   207,   246,
      20,   248,   249,   160,   161,   162,   163,   164,   147,   155,
      23,   544,   158,   235,   -76,   108,   109,   526,   424,   503,
     110,   267,   384,    24,   111,   385,   304,    31,   558,   171,
     172,   158,   173,   174,    25,   191,   131,   160,   161,   162,
     163,   164,    26,   112,    44,   272,   284,   285,   196,   275,
      43,   277,   278,   445,     1,   281,   160,   161,   162,   163,
     164,   288,   533,   108,   128,   173,   174,    33,   110,    45,
     206,   207,   111,    33,    68,   511,    46,   373,   309,   114,
      47,   478,   479,   480,   303,   482,    60,    61,    62,   306,
     307,   112,   528,   529,   155,   156,   157,   158,   206,   207,
     402,   403,    48,   578,    51,   374,    53,   320,   349,   350,
     337,   472,   207,   545,   356,   159,   317,   359,   360,   578,
     450,   451,   160,   161,   162,   163,   164,   206,   207,   436,
     550,   551,   274,   387,   486,    59,   344,   389,    64,    96,
      36,    65,   390,    37,    68,    67,    38,    39,   171,   172,
      97,   173,   174,   361,    72,   362,    40,    68,   469,   368,
     370,   391,   155,    75,   394,   158,   375,   589,   590,    68,
      68,   409,    76,   381,   601,    68,    98,    99,    90,   395,
     472,   207,   100,   159,   101,   102,   255,    68,   341,   342,
     160,   161,   162,   163,   164,   417,   103,   104,   619,    91,
     412,   413,   437,   438,   105,   443,   444,    95,    96,   117,
     118,   122,   288,   124,   128,   591,   404,   514,   133,   137,
     136,   426,   405,   134,   530,   641,   406,   407,   143,   145,
     148,   646,   368,   149,   166,   370,   168,   178,   181,   183,
     128,   534,   408,   431,   432,    98,   433,   499,   185,   131,
     394,   100,   187,   101,   102,   188,   192,   193,   209,   409,
     210,   211,   227,   295,   296,   103,   104,   171,   172,   214,
     173,   174,   635,   434,   564,   245,   229,   240,   247,   489,
     251,   643,   260,   501,   241,   270,   242,   276,   532,   580,
     301,   155,   156,   157,   158,   252,   250,   273,   311,    68,
     279,   283,   288,   312,   315,   321,   107,   322,   323,   548,
     324,   330,   159,   602,   332,   326,    68,    68,   130,   160,
     161,   162,   163,   164,   327,   331,   333,   527,   146,   338,
     339,   346,   571,   572,   150,   151,   153,    68,   343,   348,
     546,   536,   368,   345,   583,   584,   352,   355,   177,   404,
     357,   363,   372,   592,   593,   493,   377,   380,   382,   406,
     407,   399,   171,   172,   410,   173,   174,   415,   197,   199,
     606,   271,   416,   128,   418,   408,   212,   421,   422,   213,
     425,   423,   442,   575,   429,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   588,   430,    68,   439,
     446,   440,   464,   595,   454,   447,   455,   457,   599,   600,
     458,   475,   239,   160,   161,   162,   163,   164,   244,   608,
     609,   460,    68,   470,   473,   612,   613,   614,   474,   465,
     476,   466,   254,   256,   258,   226,   477,   622,   481,   483,
     265,   266,   498,   484,   485,   488,    96,   491,   494,    68,
     154,   495,   496,   497,   504,    68,    96,   137,   505,   639,
     510,   515,   152,   506,   507,   508,   645,    97,   512,   517,
     516,   519,   152,   518,   521,   531,   537,   155,   156,   157,
     158,   431,   432,    98,   433,   535,   291,   540,   292,   100,
     293,   101,   102,    98,    99,   549,   553,   555,   159,   100,
     562,   101,   102,   103,   104,   160,   161,   162,   163,   164,
     560,   434,   565,   103,   104,   567,   559,   314,   568,   569,
     561,   105,   570,   576,    96,   574,   318,   319,   577,   582,
     573,   594,   610,   611,   617,   137,   620,   596,   581,   314,
     152,   603,   585,   586,   587,   618,   623,    96,   624,   626,
     625,   629,   631,   630,   632,   597,   598,   633,    97,   634,
     637,    98,    99,   636,   604,   605,   638,   100,   607,   101,
     102,   640,    96,   642,     5,    17,   243,   316,   615,   367,
     644,   103,   104,    97,    98,    99,   448,   621,    96,   138,
     100,   616,   101,   102,   257,   627,   628,   414,   509,    97,
     539,   398,     0,   386,   103,   104,   290,     0,   487,    98,
      99,   459,   105,     0,     0,   100,     0,   101,   102,   259,
       0,     0,     0,     0,   189,    98,    99,     0,     0,   103,
     104,   100,     0,   101,   102,     0,    96,   105,   155,   156,
     157,   158,     0,     0,     0,   103,   104,   137,   367,     0,
       0,     0,     0,   105,     0,     0,     0,     0,   314,   159,
     462,    96,     0,     0,     0,   199,   160,   161,   162,   163,
     164,     0,    97,    98,    99,     0,     0,     0,     0,   100,
       0,   101,   102,     0,    96,     0,     0,     0,     0,   490,
       0,     0,     0,   103,   104,   137,     0,     0,    98,   396,
       0,   138,     0,     0,   100,   502,   101,   102,   523,   524,
       0,     0,     0,     0,     0,     0,     0,     0,   103,   104,
       0,    98,   500,     0,     0,     0,   105,   100,     0,   101,
     102,     0,     0,     0,   525,   314,   155,   156,   157,   158,
       0,   103,   104,     0,     0,     0,     0,     0,     0,   138,
     155,   156,   157,   158,   541,   542,     0,   159,     0,     0,
       0,     0,     0,     0,   160,   161,   162,   163,   164,     0,
       0,   159,   155,   156,   157,   158,     0,     0,   160,   161,
     162,   163,   164,     0,   155,   156,   157,   158,     0,     0,
       0,   269,     0,   159,     0,     0,   155,   156,   157,   158,
     160,   161,   162,   163,   164,   159,     0,     0,     0,     0,
     280,     0,   160,   161,   162,   163,   164,   159,   155,   156,
     157,   158,   297,     0,   160,   161,   162,   163,   164,     0,
       0,     0,     0,     0,   492,     0,     0,     0,     0,   159,
     155,   156,   157,   158,     0,     0,   160,   161,   162,   163,
     164,     0,   155,   156,   157,   158,   543,     0,   201,     0,
       0,   159,   202,   203,   155,   156,   157,   158,   160,   161,
     162,   163,   204,   159,     0,     0,     0,   215,     0,     0,
     160,   161,   162,   163,   164,   159,     0,     0,     0,   215,
       0,     0,   160,   161,   162,   163,   164,     0,     0,   556,
       0,   268,   155,   156,   157,   158,     0,     0,     0,     0,
       0,   557,     0,     0,   155,   156,   157,   158,     0,     0,
       0,     0,     0,   159,   205,     0,   155,   156,   157,   158,
     160,   161,   162,   163,   164,   159,     0,   335,   155,   156,
     157,   158,   160,   161,   162,   163,   164,   159,     0,     0,
       0,     0,     0,     0,   160,   161,   162,   163,   164,   159,
     155,   156,   157,   158,     0,     0,   160,   161,   162,   163,
     164,     0,   155,   156,   157,   158,     0,   155,   201,   157,
     158,   159,   202,   203,     0,     0,     0,     0,   160,   161,
     162,   163,   204,   159,     0,     0,     0,     0,   159,     0,
     160,   161,   162,   163,   164,   160,   161,   162,   163,   164
};

static const yytype_int16 yycheck[] =
{
       0,    95,   434,    63,   329,    39,    92,    67,   179,     9,
      10,   308,    72,    28,   281,    15,   116,    17,   122,   422,
     180,   402,     3,    38,    24,    25,    26,   131,   112,    22,
      26,    31,    37,     4,     3,    51,     3,    52,    43,    44,
     264,    41,    51,     3,    12,    13,    14,    51,    19,    61,
      50,   137,   138,    53,    68,    52,    43,    44,    58,    59,
      43,    44,    76,    79,    34,    18,    66,    83,    83,    39,
      79,    24,    86,    85,    27,    79,    81,    77,    31,    93,
       0,    81,   166,    30,    52,    81,    79,   171,   172,   173,
     174,   175,    51,    80,    52,    52,     3,    80,   112,    52,
       7,   116,    60,    84,    51,    52,    51,   267,   122,     5,
     334,   492,    81,    82,    81,    82,    61,   131,   550,   119,
      79,   207,   136,   347,    83,     3,   126,    79,    30,   532,
     427,    83,    21,   565,    79,   359,   360,    79,    81,    82,
      82,   365,   409,   303,    74,    75,   306,    51,    52,    51,
      52,    55,   166,   377,    45,    46,    60,   171,   172,   173,
     174,   175,    35,    15,    16,    43,    44,    45,    46,   340,
      43,    44,   272,    64,   208,    79,    19,   177,   278,   283,
      71,    72,    73,    74,    75,    41,    64,    43,    44,   189,
      52,   191,   192,    71,    72,    73,    74,    75,    51,    43,
       6,   526,    46,    81,    31,    51,    52,   504,    61,   476,
      56,   211,    81,     5,    60,    84,   276,    52,   543,    71,
      72,    46,    74,    75,    79,    52,    79,    71,    72,    73,
      74,    75,    79,    79,    82,   235,     6,     7,   252,   239,
      80,   241,   242,   414,     3,   245,    71,    72,    73,    74,
      75,   251,    35,    51,    52,    74,    75,   272,    56,    80,
      43,    44,    60,   278,   264,   489,    82,   353,   282,   283,
      52,   442,   443,   444,   274,   446,     8,     9,    10,   279,
     280,    79,   506,   507,    43,    44,    45,    46,    43,    44,
      81,    82,    52,    35,    52,   355,    81,   297,   332,   333,
     315,    43,    44,   527,   338,    64,   294,   341,   342,    35,
      51,    52,    71,    72,    73,    74,    75,    43,    44,   405,
      36,    37,    81,    51,    52,    81,   326,    55,     5,    14,
      17,     5,    60,    20,   334,    82,    23,    24,    71,    72,
      25,    74,    75,   343,    82,   345,    33,   347,   434,   349,
     350,    79,    43,    53,   368,    46,   356,    36,    37,   359,
     360,   375,    79,   363,   588,   365,    51,    52,    18,   369,
      43,    44,    57,    64,    59,    60,    61,   377,   318,   319,
      71,    72,    73,    74,    75,   385,    71,    72,   612,    31,
     378,   379,   406,   407,    79,   412,   413,     6,    14,    61,
      18,    79,   402,     7,    52,   576,    28,   493,    65,    25,
      79,   399,    34,    19,   508,   639,    38,    39,    82,    79,
      79,   645,   422,    58,    79,   425,    80,     4,    61,    80,
      52,   517,    54,    49,    50,    51,    52,   471,     6,    79,
     454,    57,    61,    59,    60,    65,    61,    52,     8,   463,
      61,    79,    53,    15,    16,    71,    72,    71,    72,    61,
      74,    75,   633,    79,   550,    61,    80,    80,    80,   457,
      80,   642,    24,   473,    81,    66,    79,    21,   512,   565,
      51,    43,    44,    45,    46,    84,    81,    81,    11,   489,
      79,    79,   492,    11,    32,    80,    75,    80,    80,   533,
      80,    65,    64,   589,    79,    81,   506,   507,    87,    71,
      72,    73,    74,    75,    80,    80,    79,   505,    97,    24,
      18,    80,   556,   557,   103,   104,   105,   527,    81,    61,
     530,   519,   532,    81,   568,   569,    60,    82,   117,    28,
      41,    81,    52,   577,   578,    34,    81,    18,    18,    38,
      39,    80,    71,    72,    18,    74,    75,    18,   137,   138,
     594,    80,    52,    52,    26,    54,   145,    30,    84,   148,
      84,    80,    31,   561,    61,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   574,    81,   588,    81,
      20,    82,   430,   581,    66,    81,    61,    81,   586,   587,
      66,   439,   181,    71,    72,    73,    74,    75,   187,   597,
     598,     6,   612,    35,     5,   603,   604,   605,     8,    79,
      61,    79,   201,   202,   203,   204,    65,   615,    81,    81,
     209,   210,   470,    51,    85,    66,    14,    11,    52,   639,
      16,    52,    48,    80,    61,   645,    14,    25,    81,   637,
      51,    80,    30,    81,    81,    81,   644,    25,    79,    43,
      80,   499,    30,    18,    26,    80,    48,    43,    44,    45,
      46,    49,    50,    51,    52,    34,   255,    18,   257,    57,
     259,    59,    60,    51,    52,    81,    61,    38,    64,    57,
      18,    59,    60,    71,    72,    71,    72,    73,    74,    75,
      80,    79,    34,    71,    72,    18,   544,   286,    66,    66,
     548,    79,    81,    31,    14,    81,   295,   296,    35,    34,
     558,    35,    18,    18,    40,    25,    18,    81,   566,   308,
      30,    81,   570,   571,   572,    40,    81,    14,    81,    18,
      34,    81,    18,    34,    81,   583,   584,    31,    25,    18,
      81,    51,    52,    34,   592,   593,    81,    57,   596,    59,
      60,    18,    14,    31,     1,    13,   185,   289,   606,   348,
      81,    71,    72,    25,    51,    52,   417,   614,    14,    79,
      57,   609,    59,    60,    61,   623,   624,   380,   485,    25,
     521,   370,    -1,   367,    71,    72,   252,    -1,   454,    51,
      52,   425,    79,    -1,    -1,    57,    -1,    59,    60,    61,
      -1,    -1,    -1,    -1,    29,    51,    52,    -1,    -1,    71,
      72,    57,    -1,    59,    60,    -1,    14,    79,    43,    44,
      45,    46,    -1,    -1,    -1,    71,    72,    25,   417,    -1,
      -1,    -1,    -1,    79,    -1,    -1,    -1,    -1,   427,    64,
     429,    14,    -1,    -1,    -1,   434,    71,    72,    73,    74,
      75,    -1,    25,    51,    52,    -1,    -1,    -1,    -1,    57,
      -1,    59,    60,    -1,    14,    -1,    -1,    -1,    -1,   458,
      -1,    -1,    -1,    71,    72,    25,    -1,    -1,    51,    52,
      -1,    79,    -1,    -1,    57,   474,    59,    60,    15,    16,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    71,    72,
      -1,    51,    52,    -1,    -1,    -1,    79,    57,    -1,    59,
      60,    -1,    -1,    -1,   503,   504,    43,    44,    45,    46,
      -1,    71,    72,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      43,    44,    45,    46,   523,   524,    -1,    64,    -1,    -1,
      -1,    -1,    -1,    -1,    71,    72,    73,    74,    75,    -1,
      -1,    64,    43,    44,    45,    46,    -1,    -1,    71,    72,
      73,    74,    75,    -1,    43,    44,    45,    46,    -1,    -1,
      -1,    84,    -1,    64,    -1,    -1,    43,    44,    45,    46,
      71,    72,    73,    74,    75,    64,    -1,    -1,    -1,    -1,
      81,    -1,    71,    72,    73,    74,    75,    64,    43,    44,
      45,    46,    81,    -1,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    -1,    -1,    81,    -1,    -1,    -1,    -1,    64,
      43,    44,    45,    46,    -1,    -1,    71,    72,    73,    74,
      75,    -1,    43,    44,    45,    46,    81,    -1,    61,    -1,
      -1,    64,    65,    66,    43,    44,    45,    46,    71,    72,
      73,    74,    75,    64,    -1,    -1,    -1,    80,    -1,    -1,
      71,    72,    73,    74,    75,    64,    -1,    -1,    -1,    80,
      -1,    -1,    71,    72,    73,    74,    75,    -1,    -1,    40,
      -1,    80,    43,    44,    45,    46,    -1,    -1,    -1,    -1,
      -1,    40,    -1,    -1,    43,    44,    45,    46,    -1,    -1,
      -1,    -1,    -1,    64,    41,    -1,    43,    44,    45,    46,
      71,    72,    73,    74,    75,    64,    -1,    42,    43,    44,
      45,    46,    71,    72,    73,    74,    75,    64,    -1,    -1,
      -1,    -1,    -1,    -1,    71,    72,    73,    74,    75,    64,
      43,    44,    45,    46,    -1,    -1,    71,    72,    73,    74,
      75,    -1,    43,    44,    45,    46,    -1,    43,    61,    45,
      46,    64,    65,    66,    -1,    -1,    -1,    -1,    71,    72,
      73,    74,    75,    64,    -1,    -1,    -1,    -1,    64,    -1,
      71,    72,    73,    74,    75,    71,    72,    73,    74,    75
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,    87,    88,    89,    89,     0,     4,    19,    98,
     105,    52,    52,    88,    88,     5,    21,   105,     7,    88,
      52,    88,   111,     6,     5,    79,    79,    88,    88,    88,
     108,    52,    99,   112,   100,   112,    17,    20,    23,    24,
      33,    84,    88,    80,    82,    80,    82,    52,    52,   112,
     106,    52,    88,    81,    12,    13,    14,    52,   102,    81,
       8,     9,    10,   101,     5,     5,    90,    82,    88,   113,
     115,   116,    82,   112,    88,    53,    79,    81,    82,    88,
      88,   102,    22,    79,    88,   102,    24,    27,    52,   136,
      18,    31,    34,    39,   102,     6,    14,    25,    51,    52,
      57,    59,    60,    71,    72,    79,   136,   137,    51,    52,
      56,    60,    79,   103,   136,   140,    88,    61,    18,    81,
      82,    88,    79,   112,     7,   109,    81,    82,    52,   136,
     137,    79,    82,    65,    19,    92,    79,    25,    79,   137,
     138,   139,   136,    82,   111,    79,   137,    51,    79,    58,
     137,   137,    30,   137,    16,    43,    44,    45,    46,    64,
      71,    72,    73,    74,    75,    83,    79,   140,    80,    15,
      16,    71,    72,    74,    75,   104,    99,   137,     4,    91,
      88,    61,   103,    80,   110,     6,    88,    61,    65,    29,
     103,    52,    61,    52,   114,   127,   136,   137,   138,   137,
     138,    61,    65,    66,    75,    41,    43,    44,    94,     8,
      61,    79,   137,   137,    61,    80,   137,   137,   137,   137,
     137,   137,   137,   137,   137,   137,   137,    53,   140,    80,
     140,   140,   140,   140,   140,    81,    88,   114,   100,   137,
      80,    81,    79,   110,   137,    61,    88,    80,    88,    88,
      81,    80,    84,    80,   137,    61,   137,    61,   137,    61,
      24,    93,   138,   138,   106,   137,   137,    88,    80,    84,
      66,    80,    88,    81,    81,    88,    21,    88,    88,    79,
      81,    88,   118,    79,     6,     7,    96,   107,    88,   121,
     127,   137,   137,   137,   113,    15,    16,    81,   100,    52,
      60,    51,    99,    88,   102,    99,    88,    88,    96,   136,
     103,    11,    11,   128,   137,    32,    90,   107,   137,   137,
      88,    80,    80,    80,    80,   100,    81,    80,   100,   128,
      65,    80,    79,    79,    97,    42,   130,   112,    24,    18,
      95,    94,    94,    81,    88,    81,    80,    97,    61,   106,
     106,   113,    60,    26,    81,    82,   106,    41,   114,   106,
     106,    88,    88,    81,   113,   119,   120,   137,    88,   131,
      88,   134,    52,   138,   102,    88,   122,    81,   113,   113,
      18,    88,    18,   113,    81,    84,   130,    51,    52,    55,
      60,    79,   132,   133,   136,    88,    52,   135,   137,    80,
      37,    81,    81,    82,    28,    34,    38,    39,    54,   136,
      18,   113,   107,   107,    91,    18,    52,    88,    26,    51,
      61,    30,    84,    80,    61,    84,   107,   129,   121,    61,
      81,    49,    50,    52,    79,   117,   138,   136,   136,    81,
      82,    96,    31,    95,    95,   114,    20,    81,   119,    30,
      51,    52,   125,   126,    66,    61,   131,    81,    66,   134,
       6,   128,   137,    88,   122,    79,    79,    83,   117,   138,
      35,    35,    43,     5,     8,   122,    61,    65,   114,   114,
     114,    81,   114,    81,    51,    85,    52,   133,    66,   107,
     137,    11,    81,    34,    52,    52,    48,    80,   122,   106,
      52,    88,   137,    96,    61,    81,    81,    81,    81,   126,
      51,   113,    79,   121,   138,    80,    80,    43,    18,   122,
      83,    26,   124,    15,    16,   137,   128,   107,   113,   113,
     111,    80,   106,    35,   138,    34,   107,    48,    30,   125,
      18,   137,   137,    81,    97,   113,    88,   131,   106,    81,
      36,    37,   123,    61,    61,    38,    40,    40,    97,   122,
      80,   122,    18,   117,   138,    34,   106,    18,    66,    66,
      81,   106,   106,   122,    81,   107,    31,    35,    35,   117,
     138,   122,    34,   106,   106,   122,   122,   122,   107,    36,
      37,   114,   106,   106,    35,   107,    81,   122,   122,   107,
     107,   113,   138,    81,   122,   122,   106,   122,   107,   107,
      18,    18,   107,   107,   107,   122,   124,    40,    40,   113,
      18,   123,   107,    81,    81,    34,    18,   122,   122,    81,
      34,    18,    81,    31,    18,   114,    34,    81,    81,   107,
      18,   113,    31,   114,    81,   107,   113
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1464 of yacc.c  */
#line 757 "vhd2vl.y"
    {
        slist *sl;
          sl=output_timescale((yyvsp[(1) - (5)].sl));
          sl=addsl(sl,(yyvsp[(2) - (5)].sl));
          sl=addsl(sl,(yyvsp[(3) - (5)].sl));
          sl=addsl(sl,(yyvsp[(4) - (5)].sl));
          sl=addsl(sl,(yyvsp[(5) - (5)].sl));
          sl=addtxt(sl,"\nendmodule\n");
          slprint(sl);
          (yyval.n)=0;
        ;}
    break;

  case 3:

/* Line 1464 of yacc.c  */
#line 772 "vhd2vl.y"
    {
        slist *sl;
          sl=addsl((yyvsp[(1) - (3)].sl),(yyvsp[(2) - (3)].sl));
          sl=addsl(sl,(yyvsp[(3) - (3)].sl));
          sl=addtxt(sl,"\nendmodule\n");
          slprint(sl);
          (yyval.n)=0;
        ;}
    break;

  case 4:

/* Line 1464 of yacc.c  */
#line 780 "vhd2vl.y"
    {
        slist *sl;
          sl=addsl((yyvsp[(1) - (3)].sl),(yyvsp[(2) - (3)].sl));
          sl=addsl(sl,(yyvsp[(3) - (3)].sl));
          sl=addtxt(sl,"\nendmodule\n");
          slprint(sl);
          (yyval.n)=0;
        ;}
    break;

  case 5:

/* Line 1464 of yacc.c  */
#line 791 "vhd2vl.y"
    {(yyval.sl)=NULL; ;}
    break;

  case 6:

/* Line 1464 of yacc.c  */
#line 792 "vhd2vl.y"
    {(yyval.sl)=(yyvsp[(1) - (1)].sl); ;}
    break;

  case 7:

/* Line 1464 of yacc.c  */
#line 795 "vhd2vl.y"
    {(yyval.sl)=addtxt(indents[indent],(yyvsp[(1) - (1)].txt));;}
    break;

  case 8:

/* Line 1464 of yacc.c  */
#line 796 "vhd2vl.y"
    {
           slist *sl;
           sl=addtxt(indents[indent],(yyvsp[(1) - (2)].txt));
           (yyval.sl)=addsl(sl,(yyvsp[(2) - (2)].sl));;}
    break;

  case 9:

/* Line 1464 of yacc.c  */
#line 802 "vhd2vl.y"
    {(yyval.txt)=NULL;;}
    break;

  case 11:

/* Line 1464 of yacc.c  */
#line 804 "vhd2vl.y"
    {(yyval.txt)=NULL;;}
    break;

  case 13:

/* Line 1464 of yacc.c  */
#line 806 "vhd2vl.y"
    {(yyval.txt)=NULL;;}
    break;

  case 15:

/* Line 1464 of yacc.c  */
#line 808 "vhd2vl.y"
    {(yyval.txt)=NULL;;}
    break;

  case 19:

/* Line 1464 of yacc.c  */
#line 815 "vhd2vl.y"
    {skipRem = 1;;}
    break;

  case 20:

/* Line 1464 of yacc.c  */
#line 816 "vhd2vl.y"
    {skipRem = 0;;}
    break;

  case 21:

/* Line 1464 of yacc.c  */
#line 820 "vhd2vl.y"
    {
            slist *sl;
            sglist *p;
              sl=addtxt(NULL,"\nmodule ");
              sl=addtxt(sl,(yyvsp[(2) - (15)].txt)); /* NAME */
              /* Add the signal list */
              sl=emit_io_list(sl);
              sl=addsl(sl,(yyvsp[(7) - (15)].sl)); /* rem */
              sl=addsl(sl,(yyvsp[(8) - (15)].sl)); /* portlist */
              sl=addtxt(sl,"\n");
              p=io_list;
              if (vlog_ver == 0) {
                do{
                sl=addptxt(sl,&(p->type));
                /*sl=addtxt(sl,p->type);*/
                sl=addpar(sl,p->range);
                sl=addtxt(sl,p->name);
                /* sl=addpost(sl,p->range); */
                sl=addtxt(sl,";\n");
                p=p->next;
                } while(p!=NULL);
              }
              sl=addtxt(sl,"\n");
              sl=addsl(sl,(yyvsp[(11) - (15)].sl)); /* rem2 */
              (yyval.sl)=addtxt(sl,"\n");
            ;}
    break;

  case 22:

/* Line 1464 of yacc.c  */
#line 847 "vhd2vl.y"
    {
            slist *sl;
            sglist *p;
              if (0) fprintf(stderr,"matched ENTITY GENERIC\n");
              sl=addtxt(NULL,"\nmodule ");
              sl=addtxt(sl,(yyvsp[(2) - (23)].txt)); /* NAME */
              sl=emit_io_list(sl);
              sl=addsl(sl,(yyvsp[(7) - (23)].sl));  /* rem */
              sl=addsl(sl,(yyvsp[(8) - (23)].sl));  /* genlist */
              sl=addsl(sl,(yyvsp[(11) - (23)].sl)); /* rem */
              sl=addsl(sl,(yyvsp[(15) - (23)].sl)); /* rem */
              sl=addsl(sl,(yyvsp[(16) - (23)].sl)); /* portlist */
              sl=addtxt(sl,"\n");
              p=io_list;
              if (vlog_ver == 0) {
                do{
                sl=addptxt(sl,&(p->type));
                /*sl=addtxt(sl,p->type);*/
                sl=addpar(sl,p->range);
                sl=addtxt(sl,p->name);
                sl=addtxt(sl,";\n");
                p=p->next;
                } while(p!=NULL);
              }
              sl=addtxt(sl,"\n");
              sl=addsl(sl,(yyvsp[(19) - (23)].sl)); /* rem2 */
              (yyval.sl)=addtxt(sl,"\n");
            ;}
    break;

  case 23:

/* Line 1464 of yacc.c  */
#line 878 "vhd2vl.y"
    {
          if(dolist){
            slist *sl;
            sglist *p;
            sl=addtxt(NULL,"parameter");
            sl=addpar(sl,(yyvsp[(3) - (7)].v)); /* type */
            p=(yyvsp[(1) - (7)].sg);
            for(;;){
              sl=addtxt(sl,p->name);
              sl=addtxt(sl,"=");
              sl=addsl(sl, (yyvsp[(6) - (7)].e)->sl); /* expr */
              sl=addtxt(sl,";\n");
              p=p->next;
              if(p==NULL) break;
            }
            (yyval.sl)=addsl(sl,(yyvsp[(7) - (7)].sl)); /* rem */
          } else {
            (yyval.sl)=NULL;
          }
         ;}
    break;

  case 24:

/* Line 1464 of yacc.c  */
#line 899 "vhd2vl.y"
    {
          if(dolist){
            slist *sl;
            sglist *p;
            sl=addtxt(NULL,"parameter");
            sl=addpar(sl,(yyvsp[(3) - (9)].v)); /* type */
            p=(yyvsp[(1) - (9)].sg);
            for(;;){
              sl=addtxt(sl,p->name);
              sl=addtxt(sl,"=");
              sl=addsl(sl, (yyvsp[(6) - (9)].e)->sl); /* expr */
              sl=addtxt(sl,";\n");
              p=p->next;
              if(p==NULL) break;
            }
            (yyval.sl)=addsl(sl,(yyvsp[(8) - (9)].sl)); /* rem */
            (yyval.sl)=addsl(sl,(yyvsp[(9) - (9)].sl)); /* genlist */
          } else {
            (yyval.sl)=NULL;
          }
         ;}
    break;

  case 25:

/* Line 1464 of yacc.c  */
#line 921 "vhd2vl.y"
    {
          if(dolist){
            slist *sl;
            sglist *p;
            sl=addtxt(NULL,"parameter");
            sl=addpar(sl,(yyvsp[(3) - (6)].v)); /* type */
            p=(yyvsp[(1) - (6)].sg);
            for(;;){
              sl=addtxt(sl,p->name);
              sl=addtxt(sl,";\n");
              p=p->next;
              if(p==NULL) break;
            }
            (yyval.sl)=addsl(sl,(yyvsp[(5) - (6)].sl)); /* rem */
            (yyval.sl)=addsl(sl,(yyvsp[(6) - (6)].sl)); /* genlist */
          } else {
            (yyval.sl)=NULL;
          }
         ;}
    break;

  case 26:

/* Line 1464 of yacc.c  */
#line 941 "vhd2vl.y"
    {
          if(dolist){
            slist *sl;
            sglist *p;
            sl=addtxt(NULL,"parameter");
            sl=addpar(sl,(yyvsp[(3) - (4)].v)); /* type */
            p=(yyvsp[(1) - (4)].sg);
            for(;;){
              sl=addtxt(sl,p->name);
              sl=addtxt(sl,";\n");
              p=p->next;
              if(p==NULL) break;
            }
            (yyval.sl)=addsl(sl,(yyvsp[(4) - (4)].sl)); /* rem */
          } else {
            (yyval.sl)=NULL;
          }
         ;}
    break;

  case 27:

/* Line 1464 of yacc.c  */
#line 962 "vhd2vl.y"
    {
            slist *sl;

              if(dolist){
                io_list=NULL;
                sl=setup_port((yyvsp[(1) - (5)].sg),(yyvsp[(3) - (5)].n),(yyvsp[(4) - (5)].v));  /* modifies io_list global */
                (yyval.sl)=addsl(sl,(yyvsp[(5) - (5)].sl));
              } else{
                free((yyvsp[(5) - (5)].sl));
                free((yyvsp[(4) - (5)].v));
              }
            ;}
    break;

  case 28:

/* Line 1464 of yacc.c  */
#line 975 "vhd2vl.y"
    {
            slist *sl;

              if(dolist){
                sl=setup_port((yyvsp[(1) - (7)].sg),(yyvsp[(3) - (7)].n),(yyvsp[(4) - (7)].v));  /* modifies io_list global */
                sl=addsl(sl,(yyvsp[(6) - (7)].sl));
                (yyval.sl)=addsl(sl,(yyvsp[(7) - (7)].sl));
              } else{
                free((yyvsp[(6) - (7)].sl));
                free((yyvsp[(4) - (7)].v));
              }
            ;}
    break;

  case 29:

/* Line 1464 of yacc.c  */
#line 988 "vhd2vl.y"
    {
            slist *sl;
              fprintf(stderr,"Warning on line %d: "
                "port default initialization ignored\n",lineno);
              if(dolist){
                io_list=NULL;
                sl=setup_port((yyvsp[(1) - (8)].sg),(yyvsp[(3) - (8)].n),(yyvsp[(4) - (8)].v));  /* modifies io_list global */
                (yyval.sl)=addsl(sl,(yyvsp[(8) - (8)].sl));
              } else{
                free((yyvsp[(8) - (8)].sl));
                free((yyvsp[(4) - (8)].v));
              }
            ;}
    break;

  case 30:

/* Line 1464 of yacc.c  */
#line 1002 "vhd2vl.y"
    {
            slist *sl;
              fprintf(stderr,"Warning on line %d: "
                "port default initialization ignored\n",lineno);
              if(dolist){
                sl=setup_port((yyvsp[(1) - (10)].sg),(yyvsp[(3) - (10)].n),(yyvsp[(4) - (10)].v));  /* modifies io_list global */
                sl=addsl(sl,(yyvsp[(9) - (10)].sl));
                (yyval.sl)=addsl(sl,(yyvsp[(10) - (10)].sl));
              } else{
                free((yyvsp[(9) - (10)].sl));
                free((yyvsp[(4) - (10)].v));
              }
            ;}
    break;

  case 31:

/* Line 1464 of yacc.c  */
#line 1017 "vhd2vl.y"
    { (yyval.n)=0;;}
    break;

  case 32:

/* Line 1464 of yacc.c  */
#line 1018 "vhd2vl.y"
    { (yyval.n)=1; ;}
    break;

  case 33:

/* Line 1464 of yacc.c  */
#line 1019 "vhd2vl.y"
    { (yyval.n)=2; ;}
    break;

  case 34:

/* Line 1464 of yacc.c  */
#line 1022 "vhd2vl.y"
    {
                (yyval.v)=new_vrange(tSCALAR);
              ;}
    break;

  case 35:

/* Line 1464 of yacc.c  */
#line 1025 "vhd2vl.y"
    {
                fprintf(stderr,"Warning on line %d: integer range ignored\n",lineno);
                (yyval.v)=new_vrange(tSCALAR);
                (yyval.v)->nlo = addtxt(NULL,"0");
                (yyval.v)->nhi = addtxt(NULL,"31");
              ;}
    break;

  case 36:

/* Line 1464 of yacc.c  */
#line 1031 "vhd2vl.y"
    {
                (yyval.v)=new_vrange(tSCALAR);
                (yyval.v)->nlo = addtxt(NULL,"0");
                (yyval.v)->nhi = addtxt(NULL,"31");
              ;}
    break;

  case 37:

/* Line 1464 of yacc.c  */
#line 1036 "vhd2vl.y"
    {(yyval.v)=(yyvsp[(3) - (4)].v);;}
    break;

  case 38:

/* Line 1464 of yacc.c  */
#line 1037 "vhd2vl.y"
    {
              sglist *sg;

                sg=lookup(type_list,(yyvsp[(1) - (1)].txt));
                if(sg)
                  (yyval.v)=sg->range;
                else{
                  fprintf(stderr,"Undefined type '%s' on line %d\n",(yyvsp[(1) - (1)].txt),lineno);
                  YYABORT;
                }
              ;}
    break;

  case 39:

/* Line 1464 of yacc.c  */
#line 1051 "vhd2vl.y"
    {
              (yyval.v)=new_vrange(tVRANGE);
              (yyval.v)->nhi=(yyvsp[(1) - (3)].e)->sl;
              (yyval.v)->nlo=(yyvsp[(3) - (3)].e)->sl;
              (yyval.v)->sizeval = -1; /* undefined size */
              /* calculate the width of this vrange */
              if ((yyvsp[(1) - (3)].e)->op == 'n' && (yyvsp[(3) - (3)].e)->op == 'n') {
                if ((yyvsp[(2) - (3)].n)==-1) { /* (nhi:natural downto nlo:natural) */
                  (yyval.v)->sizeval = (yyvsp[(1) - (3)].e)->value - (yyvsp[(3) - (3)].e)->value + 1;
                } else {      /* (nhi:natural to     nlo:natural) */
                  (yyval.v)->sizeval = (yyvsp[(3) - (3)].e)->value - (yyvsp[(1) - (3)].e)->value + 1;
                }
              } else {
                /* make an expression to calculate the width of this vrange:
                 * create an expression that calculates:
                 *   size expr = (simple_expr1) - (simple_expr2) + 1
                 */
                expdata *size_expr1  = xmalloc(sizeof(expdata));
                expdata *size_expr2  = xmalloc(sizeof(expdata));
                expdata *diff12  = xmalloc(sizeof(expdata));
                expdata *plusone = xmalloc(sizeof(expdata));
                expdata *finalexpr = xmalloc(sizeof(expdata));
                size_expr1->sl = addwrap("(",(yyvsp[(1) - (3)].e)->sl,")");
                size_expr2->sl = addwrap("(",(yyvsp[(3) - (3)].e)->sl,")");
                plusone->op='t';
                plusone->sl=addtxt(NULL,"1");
                if ((yyvsp[(2) - (3)].n)==-1) {
                  /* (simple_expr1 downto simple_expr1) */
                  diff12 = addexpr(size_expr1,'-',"-",size_expr2);
                } else {
                  /* (simple_expr1   to   simple_expr1) */
                  diff12 = addexpr(size_expr2,'-',"-",size_expr1);
                }
                finalexpr = addexpr(diff12,'+',"+",plusone);
                finalexpr->sl = addwrap("(",finalexpr->sl,")");
                (yyval.v)->size_expr = finalexpr->sl;
              }
            ;}
    break;

  case 40:

/* Line 1464 of yacc.c  */
#line 1089 "vhd2vl.y"
    {
              (yyval.v)=new_vrange(tSUBSCRIPT);
              (yyval.v)->nlo=(yyvsp[(1) - (1)].e)->sl;
          ;}
    break;

  case 41:

/* Line 1464 of yacc.c  */
#line 1093 "vhd2vl.y"
    {
              /* lookup NAME and copy its vrange */
              sglist *sg = NULL;
              if((sg=lookup(io_list,(yyvsp[(1) - (3)].txt)))==NULL) {
                sg=lookup(sig_list,(yyvsp[(1) - (3)].txt));
              }
              if(sg) {
                (yyval.v) = sg->range;
              } else {
                fprintf(stderr,"Undefined range \"%s'range\" on line %d\n",(yyvsp[(1) - (3)].txt),lineno);
                YYABORT;
              }
          ;}
    break;

  case 42:

/* Line 1464 of yacc.c  */
#line 1108 "vhd2vl.y"
    {(yyval.n)=-1;}
    break;

  case 43:

/* Line 1464 of yacc.c  */
#line 1109 "vhd2vl.y"
    {(yyval.n)=1;}
    break;

  case 44:

/* Line 1464 of yacc.c  */
#line 1114 "vhd2vl.y"
    {
               slist *sl;
                 sl=addsl((yyvsp[(6) - (15)].sl),(yyvsp[(7) - (15)].sl));
                 sl=addtxt(sl,"\n");
                 (yyval.sl)=addsl(sl,(yyvsp[(10) - (15)].sl));
               ;}
    break;

  case 45:

/* Line 1464 of yacc.c  */
#line 1123 "vhd2vl.y"
    {indent= indent < MAXINDENT ? indent + 1 : indent;;}
    break;

  case 46:

/* Line 1464 of yacc.c  */
#line 1126 "vhd2vl.y"
    {indent= indent > 0 ? indent - 1 : indent;;}
    break;

  case 47:

/* Line 1464 of yacc.c  */
#line 1129 "vhd2vl.y"
    {(yyval.sl)=NULL;;}
    break;

  case 48:

/* Line 1464 of yacc.c  */
#line 1130 "vhd2vl.y"
    {
            sglist *sg;
            slist *sl;
            int size;

              if((yyvsp[(5) - (7)].v)->vtype==tSUBSCRIPT)
                size=1;
              else
                size=-1;
              sl=(yyvsp[(1) - (7)].sl);
              sg=(yyvsp[(3) - (7)].sg);
              for(;;){
                sg->type=wire;
                sg->range=(yyvsp[(5) - (7)].v);
                sl=addptxt(sl,&(sg->type));
                sl=addpar(sl,(yyvsp[(5) - (7)].v));
                sl=addtxt(sl,sg->name);
                sl=addpost(sl,(yyvsp[(5) - (7)].v));
                sl=addtxt(sl,";");
                if(sg->next == NULL)
                  break;
                sl=addtxt(sl," ");
                sg=sg->next;
              }
              sg->next=sig_list;
              sig_list=(yyvsp[(3) - (7)].sg);
              (yyval.sl)=addrem(sl,(yyvsp[(7) - (7)].sl));
            ;}
    break;

  case 49:

/* Line 1464 of yacc.c  */
#line 1158 "vhd2vl.y"
    {
            sglist *sg;
            slist *sl;
            int size;

              if((yyvsp[(5) - (10)].v)->vtype==tSUBSCRIPT)
                size=1;
              else
                size=-1;
              sl=(yyvsp[(1) - (10)].sl);
              sg=(yyvsp[(3) - (10)].sg);
              for(;;){
                sg->type=wire;
                sg->range=(yyvsp[(5) - (10)].v);
                sl=addptxt(sl,&(sg->type));
                sl=addpar(sl,(yyvsp[(5) - (10)].v));
                sl=addtxt(sl,sg->name);
                sl=addpost(sl,(yyvsp[(5) - (10)].v));
                sl=addtxt(sl," = ");
                sl=addsl(sl,(yyvsp[(8) - (10)].e)->sl);
                sl=addtxt(sl,";");
                if(sg->next == NULL)
                  break;
                sl=addtxt(sl," ");
                sg=sg->next;
              }
              sg->next=sig_list;
              sig_list=(yyvsp[(3) - (10)].sg);
              (yyval.sl)=addrem(sl,(yyvsp[(10) - (10)].sl));
            ;}
    break;

  case 50:

/* Line 1464 of yacc.c  */
#line 1188 "vhd2vl.y"
    {
            slist * sl;
              sl=addtxt((yyvsp[(1) - (10)].sl),"parameter ");
              sl=addtxt(sl,(yyvsp[(3) - (10)].txt));
              sl=addtxt(sl," = ");
              sl=addsl(sl,(yyvsp[(8) - (10)].e)->sl);
              sl=addtxt(sl,";");
              (yyval.sl)=addrem(sl,(yyvsp[(10) - (10)].sl));
            ;}
    break;

  case 51:

/* Line 1464 of yacc.c  */
#line 1197 "vhd2vl.y"
    {
            slist *sl, *sl2;
            sglist *p;
            int n,k;
              n=0;
              sl=NULL;
              p=(yyvsp[(6) - (9)].sg);
              for(;;){
                sl=addtxt(sl,"  ");
                sl=addtxt(sl,p->name);
                sl=addtxt(sl," = ");
                sl=addval(sl,n++);
                p=p->next;
                if(p==NULL){
                  sl=addtxt(sl,";\n");
                  break;
                } else
                  sl=addtxt(sl,",\n");
              }
              n--;
              k=find_msb(n);
              sl2=addtxt(NULL,"parameter [");
              sl2=addval(sl2,k);
              sl2=addtxt(sl2,":0]\n");
              sl=addsl(sl2,sl);
              sl=addsl((yyvsp[(1) - (9)].sl),sl);
              (yyval.sl)=addrem(sl,(yyvsp[(9) - (9)].sl));
              p=xmalloc(sizeof(sglist));
              p->name=(yyvsp[(3) - (9)].txt);
              if(k>0) {
                p->range=new_vrange(tVRANGE);
                p->range->sizeval = k+1;
                p->range->nhi=addval(NULL,k);
                p->range->nlo=addtxt(NULL,"0");
              } else {
                p->range=new_vrange(tSCALAR);
              }
              p->next=type_list;
              type_list=p;
            ;}
    break;

  case 52:

/* Line 1464 of yacc.c  */
#line 1237 "vhd2vl.y"
    {
            slist *sl=NULL;
            sglist *p;
              (yyval.sl)=addrem(sl,(yyvsp[(12) - (12)].sl));
              p=xmalloc(sizeof(sglist));
              p->name=(yyvsp[(3) - (12)].txt);
              p->range=(yyvsp[(10) - (12)].v);
              p->range->xhi=(yyvsp[(7) - (12)].v)->nhi;
              p->range->xlo=(yyvsp[(7) - (12)].v)->nlo;
              p->next=type_list;
              type_list=p;
            ;}
    break;

  case 53:

/* Line 1464 of yacc.c  */
#line 1250 "vhd2vl.y"
    {
              (yyval.sl)=addsl((yyvsp[(1) - (20)].sl),(yyvsp[(20) - (20)].sl)); /* a_decl, rem4 */
              free((yyvsp[(3) - (20)].txt)); /* NAME */
              free((yyvsp[(10) - (20)].sl)); /* rem2 */
              free((yyvsp[(14) - (20)].sl));/* rem3 */
            ;}
    break;

  case 54:

/* Line 1464 of yacc.c  */
#line 1258 "vhd2vl.y"
    {(yyval.txt)=NULL;;}
    break;

  case 55:

/* Line 1464 of yacc.c  */
#line 1259 "vhd2vl.y"
    {
             if (0) fprintf(stderr,"matched opt_generic\n");
             free((yyvsp[(4) - (8)].sl));  /* rem */
             free((yyvsp[(8) - (8)].sl));  /* rem */
             (yyval.txt)=NULL;
            ;}
    break;

  case 56:

/* Line 1464 of yacc.c  */
#line 1267 "vhd2vl.y"
    {dolist = 0;;}
    break;

  case 57:

/* Line 1464 of yacc.c  */
#line 1268 "vhd2vl.y"
    {dolist = 1;;}
    break;

  case 58:

/* Line 1464 of yacc.c  */
#line 1271 "vhd2vl.y"
    {
         sglist * sg;
           if(dolist){
             sg=xmalloc(sizeof(sglist));
             sg->name=(yyvsp[(1) - (2)].txt);
             sg->next=NULL;
             (yyval.sg)=sg;
           } else{
             free((yyvsp[(1) - (2)].txt));
             (yyval.sg)=NULL;
           }
           free((yyvsp[(2) - (2)].sl));
         ;}
    break;

  case 59:

/* Line 1464 of yacc.c  */
#line 1284 "vhd2vl.y"
    {
         sglist * sg;
           if(dolist){
             sg=xmalloc(sizeof(sglist));
             sg->name=(yyvsp[(1) - (4)].txt);
             sg->next=(yyvsp[(4) - (4)].sg);
             (yyval.sg)=sg;
           } else{
             free((yyvsp[(1) - (4)].txt));
             (yyval.sg)=NULL;
           }
           free((yyvsp[(3) - (4)].sl));
         ;}
    break;

  case 60:

/* Line 1464 of yacc.c  */
#line 1299 "vhd2vl.y"
    {(yyval.sl)=addind((yyvsp[(1) - (1)].sl));;}
    break;

  case 61:

/* Line 1464 of yacc.c  */
#line 1301 "vhd2vl.y"
    {
         slist *sl;
           sl=addsl((yyvsp[(1) - (9)].sl),indents[indent]);
           sl=addtxt(sl,"assign ");
           sl=addsl(sl,(yyvsp[(2) - (9)].ss)->sl);
           findothers((yyvsp[(2) - (9)].ss),(yyvsp[(7) - (9)].sl));
           free((yyvsp[(2) - (9)].ss));
           sl=addtxt(sl," = ");
           sl=addsl(sl,(yyvsp[(7) - (9)].sl));
           sl=addtxt(sl,";\n");
           (yyval.sl)=addsl(sl,(yyvsp[(9) - (9)].sl));
         ;}
    break;

  case 62:

/* Line 1464 of yacc.c  */
#line 1313 "vhd2vl.y"
    {
         slist *sl;
           sl=addsl((yyvsp[(1) - (13)].sl),indents[indent]);
           sl=addtxt(sl,"assign ");
           sl=addsl(sl,(yyvsp[(3) - (13)].ss)->sl);
           findothers((yyvsp[(3) - (13)].ss),(yyvsp[(8) - (13)].sl));
           free((yyvsp[(3) - (13)].ss));
           sl=addtxt(sl," = ");
           sl=addsl(sl,(yyvsp[(8) - (13)].sl));
           sl=addtxt(sl,";\n");
           (yyval.sl)=addsl(sl,(yyvsp[(10) - (13)].sl));
         ;}
    break;

  case 63:

/* Line 1464 of yacc.c  */
#line 1326 "vhd2vl.y"
    {
         slist *sl;
         sglist *sg;
         char *s;
           sl=addsl((yyvsp[(1) - (11)].sl),indents[indent]);
           sl=addtxt(sl,"always @(*) begin\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"  case(");
           sl=addsl(sl,(yyvsp[(3) - (11)].e)->sl);
           free((yyvsp[(3) - (11)].e));
           sl=addtxt(sl,")\n");
           if((yyvsp[(5) - (11)].sl))
             sl=addsl(sl,(yyvsp[(5) - (11)].sl));
           s=sbottom((yyvsp[(7) - (11)].ss)->sl);
           if((sg=lookup(io_list,s))==NULL)
             sg=lookup(sig_list,s);
           if(sg)
             sg->type=reg;
           findothers((yyvsp[(7) - (11)].ss),(yyvsp[(10) - (11)].sl));
           free((yyvsp[(7) - (11)].ss));
           sl=addsl(sl,(yyvsp[(10) - (11)].sl));
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"  endcase\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n\n");
           (yyval.sl)=addsl(sl,(yyvsp[(11) - (11)].sl));
         ;}
    break;

  case 64:

/* Line 1464 of yacc.c  */
#line 1354 "vhd2vl.y"
    {
         slist *sl;
           sl=addsl((yyvsp[(1) - (15)].sl),indents[indent]);
           sl=addtxt(sl,(yyvsp[(4) - (15)].txt)); /* NAME2 */
           sl=addtxt(sl," ");
           sl=addtxt(sl,(yyvsp[(2) - (15)].txt)); /* NAME1 */
           sl=addtxt(sl,"(\n");
           sl=addsl(sl,indents[indent]);
           sl=addsl(sl,(yyvsp[(10) - (15)].sl));  /* map_list */
           sl=addtxt(sl,");\n\n");
           (yyval.sl)=addsl(sl,(yyvsp[(15) - (15)].sl)); /* a_body */
         ;}
    break;

  case 65:

/* Line 1464 of yacc.c  */
#line 1367 "vhd2vl.y"
    {
         slist *sl;
           sl=addsl((yyvsp[(1) - (21)].sl),indents[indent]);
           sl=addtxt(sl,(yyvsp[(4) - (21)].txt)); /* NAME2 (component name) */
           if ((yyvsp[(5) - (21)].sl)) {
             sl=addsl(sl,(yyvsp[(5) - (21)].sl));
             sl=addsl(sl,indents[indent]);
           }
           sl=addtxt(sl," #(\n");
           sl=addsl(sl,indents[indent]);
           sl=addsl(sl,(yyvsp[(10) - (21)].sl)); /* (generic) map_list */
           sl=addtxt(sl,")\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,(yyvsp[(2) - (21)].txt)); /* NAME1 (instance name) */
           sl=addtxt(sl,"(\n");
           sl=addsl(sl,indents[indent]);
           sl=addsl(sl,(yyvsp[(17) - (21)].sl)); /* map_list */
           sl=addtxt(sl,");\n\n");
           (yyval.sl)=addsl(sl,(yyvsp[(21) - (21)].sl)); /* a_body */
         ;}
    break;

  case 66:

/* Line 1464 of yacc.c  */
#line 1387 "vhd2vl.y"
    {
         slist *sl;
           if (0) fprintf(stderr,"process style 1\n");
           sl=add_always((yyvsp[(1) - (16)].sl),(yyvsp[(4) - (16)].sl),(yyvsp[(6) - (16)].sl),0);
           sl=addsl(sl,(yyvsp[(10) - (16)].sl));
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n\n");
           (yyval.sl)=addsl(sl,(yyvsp[(16) - (16)].sl));
         ;}
    break;

  case 67:

/* Line 1464 of yacc.c  */
#line 1397 "vhd2vl.y"
    {
           slist *sl;
             if (0) fprintf(stderr,"process style 2: if then end if\n");
             sl=add_always((yyvsp[(1) - (23)].sl),(yyvsp[(4) - (23)].sl),(yyvsp[(6) - (23)].sl),1);
             if((yyvsp[(10) - (23)].sl)){
               sl=addsl(sl,indents[indent]);
               sl=addsl(sl,(yyvsp[(10) - (23)].sl));
             }
             sl=addsl(sl,(yyvsp[(14) - (23)].sl));
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"end\n\n");
             (yyval.sl)=addsl(sl,(yyvsp[(23) - (23)].sl));
         ;}
    break;

  case 68:

/* Line 1464 of yacc.c  */
#line 1415 "vhd2vl.y"
    {
           slist *sl;
             if (0) fprintf(stderr,"process style 3: if then elsif then end if\n");
             sl=add_always((yyvsp[(1) - (31)].sl),(yyvsp[(4) - (31)].sl),(yyvsp[(6) - (31)].sl),1);
             if((yyvsp[(10) - (31)].sl)){
               sl=addsl(sl,indents[indent]);
               sl=addsl(sl,(yyvsp[(10) - (31)].sl));
             }
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"  if(");
             sl=addsl(sl,(yyvsp[(12) - (31)].sl));
             sl=addtxt(sl,") begin\n");
             sl=addsl(sl,(yyvsp[(15) - (31)].sl));
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"  end else begin\n");
             sl=addsl(sl,(yyvsp[(21) - (31)].sl));
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"  end\n");
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"end\n\n");
             (yyval.sl)=addsl(sl,(yyvsp[(31) - (31)].sl));
         ;}
    break;

  case 69:

/* Line 1464 of yacc.c  */
#line 1442 "vhd2vl.y"
    {
           slist *sl;
             if (0) fprintf(stderr,"process style 4: if then else if then end if\n");
             sl=add_always((yyvsp[(1) - (35)].sl),(yyvsp[(4) - (35)].sl),(yyvsp[(6) - (35)].sl),1);
             if((yyvsp[(10) - (35)].sl)){
               sl=addsl(sl,indents[indent]);
               sl=addsl(sl,(yyvsp[(10) - (35)].sl));
             }
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"  if(");
             sl=addsl(sl,(yyvsp[(12) - (35)].sl)); /* exprc */
             sl=addtxt(sl,") begin\n");
             sl=addsl(sl,(yyvsp[(15) - (35)].sl)); /* p_body:1 */
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"  end else begin\n");
             sl=addsl(sl,(yyvsp[(22) - (35)].sl)); /* p_body:2 */
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"  end\n");
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"end\n\n");
             (yyval.sl)=addsl(sl,(yyvsp[(35) - (35)].sl)); /* a_body */
         ;}
    break;

  case 70:

/* Line 1464 of yacc.c  */
#line 1467 "vhd2vl.y"
    {
         slist *sl;
         blknamelist *tname_list;
           sl=addsl((yyvsp[(1) - (11)].sl),indents[indent]);
           sl=addtxt(sl,"generate ");
           sl=addtxt(sl,"if (");
           sl=addsl(sl,(yyvsp[(3) - (11)].sl)); /* exprc */
           sl=addtxt(sl,") begin: ");
           tname_list=blkname_list;
           sl=addtxt(sl,tname_list->name);
           blkname_list=blkname_list->next;
           if (tname_list!=NULL) {
           free(tname_list->name);
           free(tname_list);
           }
           sl=addtxt(sl,"\n");
           sl=addsl(sl,indents[indent]);
           sl=addsl(sl,(yyvsp[(6) - (11)].sl));   /* a_body:1 */
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"endgenerate\n");
           (yyval.sl)=addsl(sl,(yyvsp[(11) - (11)].sl));    /* a_body:2 */
         ;}
    break;

  case 71:

/* Line 1464 of yacc.c  */
#line 1492 "vhd2vl.y"
    {
         slist *sl;
         blknamelist *tname_list;
           sl=addsl((yyvsp[(1) - (15)].sl),indents[indent]);
           sl=addtxt(sl,"genvar ");
           sl=addsl(sl,(yyvsp[(3) - (15)].ss)->sl); /* signal */
           sl=addtxt(sl,";\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"generate ");
           sl=addtxt(sl,"for (");
           sl=addsl(sl,(yyvsp[(3) - (15)].ss)->sl); /* signal */
           sl=addtxt(sl,"=");
           sl=addsl(sl,(yyvsp[(5) - (15)].e)->sl); /* expr:1 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[(3) - (15)].ss)->sl); /* signal */
           sl=addtxt(sl," <= ");
           sl=addsl(sl,(yyvsp[(7) - (15)].e)->sl); /* expr:2 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[(3) - (15)].ss)->sl); /* signal */
           sl=addtxt(sl," = ");
           sl=addsl(sl,(yyvsp[(3) - (15)].ss)->sl); /* signal */
           sl=addtxt(sl," + 1) begin: ");
           tname_list=blkname_list;
           sl=addtxt(sl,tname_list->name);
           blkname_list=blkname_list->next;
           if (tname_list!=NULL) {
           free(tname_list->name);
           free(tname_list);
           }
           sl=addtxt(sl,"\n");
           sl=addsl(sl,indents[indent]);
           sl=addsl(sl,(yyvsp[(10) - (15)].sl));   /* a_body:1 */
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"endgenerate\n");
           (yyval.sl)=addsl(sl,(yyvsp[(15) - (15)].sl));    /* a_body:2 */
         ;}
    break;

  case 72:

/* Line 1464 of yacc.c  */
#line 1531 "vhd2vl.y"
    {
         slist *sl;
           blknamelist* tname_list;
           sl=addsl((yyvsp[(1) - (15)].sl),indents[indent]);
           sl=addtxt(sl,"genvar ");
           sl=addsl(sl,(yyvsp[(3) - (15)].ss)->sl); /* signal */
           sl=addtxt(sl,";\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"generate ");
           sl=addtxt(sl,"for (");
           sl=addsl(sl,(yyvsp[(3) - (15)].ss)->sl); /* signal */
           sl=addtxt(sl,"=");
           sl=addsl(sl,(yyvsp[(5) - (15)].e)->sl); /* expr:1 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[(3) - (15)].ss)->sl); /* signal */
           sl=addtxt(sl," >= ");
           sl=addsl(sl,(yyvsp[(7) - (15)].e)->sl); /* expr:2 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[(3) - (15)].ss)->sl); /* signal */
           sl=addtxt(sl," = ");
           sl=addsl(sl,(yyvsp[(3) - (15)].ss)->sl); /* signal */
           sl=addtxt(sl," - 1) begin: ");
           tname_list=blkname_list;
           sl=addtxt(sl,tname_list->name);
           blkname_list=blkname_list->next;
           if (tname_list!=NULL) {
           free(tname_list->name);
           free(tname_list);
           }
           sl=addtxt(sl,"\n");
           sl=addsl(sl,(yyvsp[(10) - (15)].sl));   /* a_body:1 */
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"endgenerate\n");
           (yyval.sl)=addsl(sl,(yyvsp[(15) - (15)].sl));    /* a_body:2 */
         ;}
    break;

  case 73:

/* Line 1464 of yacc.c  */
#line 1570 "vhd2vl.y"
    {(yyval.sl)=NULL;;}
    break;

  case 74:

/* Line 1464 of yacc.c  */
#line 1571 "vhd2vl.y"
    {free((yyvsp[(1) - (1)].txt)); (yyval.sl)=NULL;;}
    break;

  case 75:

/* Line 1464 of yacc.c  */
#line 1574 "vhd2vl.y"
    {(yyval.sl)=(yyvsp[(1) - (1)].sl);;}
    break;

  case 76:

/* Line 1464 of yacc.c  */
#line 1575 "vhd2vl.y"
    {(yyval.sl)=(yyvsp[(1) - (3)].sl); free((yyvsp[(2) - (3)].txt));;}
    break;

  case 77:

/* Line 1464 of yacc.c  */
#line 1577 "vhd2vl.y"
    {(yyval.sl)=(yyvsp[(1) - (1)].sl);;}
    break;

  case 78:

/* Line 1464 of yacc.c  */
#line 1578 "vhd2vl.y"
    {
           blknamelist *tname_list;
           tname_list = xmalloc (sizeof(blknamelist));
           tname_list->name = xmalloc(strlen((yyvsp[(2) - (3)].txt)));
           strcpy(tname_list->name, (yyvsp[(2) - (3)].txt));
           tname_list->next = blkname_list;
           blkname_list=tname_list;
           (yyval.sl)=(yyvsp[(1) - (3)].sl);
           free((yyvsp[(2) - (3)].txt));
         ;}
    break;

  case 79:

/* Line 1464 of yacc.c  */
#line 1590 "vhd2vl.y"
    {(yyval.sl)=addwrap("(",(yyvsp[(2) - (3)].sl),")");;}
    break;

  case 80:

/* Line 1464 of yacc.c  */
#line 1591 "vhd2vl.y"
    {
         push_clkedge((yyvsp[(5) - (5)].sl)->data.sl->data.txt[0]-'0', "name'event and exprc");
       ;}
    break;

  case 81:

/* Line 1464 of yacc.c  */
#line 1594 "vhd2vl.y"
    {
         push_clkedge((yyvsp[(1) - (5)].sl)->data.sl->data.txt[0]-'0', "exprc and name'event");
       ;}
    break;

  case 82:

/* Line 1464 of yacc.c  */
#line 1597 "vhd2vl.y"
    {
         push_clkedge(1, "explicit");
       ;}
    break;

  case 83:

/* Line 1464 of yacc.c  */
#line 1600 "vhd2vl.y"
    {
         push_clkedge(0, "explicit");
       ;}
    break;

  case 84:

/* Line 1464 of yacc.c  */
#line 1605 "vhd2vl.y"
    {dowith=1;;}
    break;

  case 85:

/* Line 1464 of yacc.c  */
#line 1607 "vhd2vl.y"
    {(yyval.sl)=(yyvsp[(1) - (2)].sl);;}
    break;

  case 86:

/* Line 1464 of yacc.c  */
#line 1608 "vhd2vl.y"
    {
            slist *sl;
              if((yyvsp[(3) - (4)].sl)){
                sl=addsl((yyvsp[(1) - (4)].sl),(yyvsp[(3) - (4)].sl));
                (yyval.sl)=addsl(sl,(yyvsp[(4) - (4)].sl));
              } else
                (yyval.sl)=addsl((yyvsp[(1) - (4)].sl),(yyvsp[(4) - (4)].sl));
            ;}
    break;

  case 87:

/* Line 1464 of yacc.c  */
#line 1616 "vhd2vl.y"
    {
            slist *sl;
              sl=addtxt(indents[indent],"    default : ");
              sl=addsl(sl,slwith);
              sl=addtxt(sl," <= ");
              if(delay && (yyvsp[(2) - (5)].n)){
                sl=addtxt(sl,"# ");
                sl=addval(sl,(yyvsp[(2) - (5)].n));
                sl=addtxt(sl," ");
              }
              if((yyvsp[(1) - (5)].e)->op == 'c')
                sl=addsl(sl,addwrap("{",(yyvsp[(1) - (5)].e)->sl,"}"));
              else
                sl=addsl(sl,(yyvsp[(1) - (5)].e)->sl);
              free((yyvsp[(1) - (5)].e));
              delay=1;
              (yyval.sl)=addtxt(sl,";\n");
            ;}
    break;

  case 88:

/* Line 1464 of yacc.c  */
#line 1635 "vhd2vl.y"
    {
            slist *sl;
              sl=addtxt(indents[indent],"    ");
              sl=addsl(sl,(yyvsp[(4) - (4)].sl));
              sl=addtxt(sl," : ");
              sl=addsl(sl,slwith);
              sl=addtxt(sl," <= ");
              if(delay && (yyvsp[(2) - (4)].n)){
                sl=addtxt(sl,"# ");
                sl=addval(sl,(yyvsp[(2) - (4)].n));
                sl=addtxt(sl," ");
              }
              if((yyvsp[(1) - (4)].e)->op == 'c')
                sl=addsl(sl,addwrap("{",(yyvsp[(1) - (4)].e)->sl,"}"));
              else
                sl=addsl(sl,(yyvsp[(1) - (4)].e)->sl);
              free((yyvsp[(1) - (4)].e));
              delay=1;
              (yyval.sl)=addtxt(sl,";\n");
            ;}
    break;

  case 89:

/* Line 1464 of yacc.c  */
#line 1656 "vhd2vl.y"
    {(yyval.sl)=(yyvsp[(1) - (1)].sl);}
    break;

  case 90:

/* Line 1464 of yacc.c  */
#line 1657 "vhd2vl.y"
    {
         slist *sl;
         sglist *sg, *p;
           sl=addtxt((yyvsp[(1) - (7)].sl),"    reg");
           sl=addpar(sl,(yyvsp[(5) - (7)].v));
           free((yyvsp[(5) - (7)].v));
           sg=(yyvsp[(3) - (7)].sg);
           for(;;){
             sl=addtxt(sl,sg->name);
             p=sg;
             sg=sg->next;
             free(p);
             if(sg)
               sl=addtxt(sl,", ");
             else
               break;
           }
           sl=addtxt(sl,";\n");
           (yyval.sl)=addsl(sl,(yyvsp[(7) - (7)].sl));
         ;}
    break;

  case 91:

/* Line 1464 of yacc.c  */
#line 1677 "vhd2vl.y"
    {
         slist *sl;
         sglist *sg, *p;
           sl=addtxt((yyvsp[(1) - (10)].sl),"    reg");
           sl=addpar(sl,(yyvsp[(5) - (10)].v));
           free((yyvsp[(5) - (10)].v));
           sg=(yyvsp[(3) - (10)].sg);
           for(;;){
             sl=addtxt(sl,sg->name);
             p=sg;
             sg=sg->next;
             free(p);
             if(sg)
               sl=addtxt(sl,", ");
             else
               break;
           }
           sl=addtxt(sl," = ");
           sl=addsl(sl,(yyvsp[(8) - (10)].e)->sl);
           sl=addtxt(sl,";\n");
           (yyval.sl)=addsl(sl,(yyvsp[(10) - (10)].sl));
         ;}
    break;

  case 92:

/* Line 1464 of yacc.c  */
#line 1701 "vhd2vl.y"
    {(yyval.sl)=(yyvsp[(1) - (1)].sl);;}
    break;

  case 93:

/* Line 1464 of yacc.c  */
#line 1703 "vhd2vl.y"
    {
         slist *sl;
           sl=addsl((yyvsp[(1) - (9)].sl),indents[indent]);
           sl=addsl(sl,(yyvsp[(2) - (9)].ss)->sl);
           findothers((yyvsp[(2) - (9)].ss),(yyvsp[(6) - (9)].e)->sl);
           sl=addtxt(sl," = ");
           if((yyvsp[(6) - (9)].e)->op == 'c')
             sl=addsl(sl,addwrap("{",(yyvsp[(6) - (9)].e)->sl,"}"));
           else
             sl=addsl(sl,(yyvsp[(6) - (9)].e)->sl);
           sl=addtxt(sl,";\n");
           (yyval.sl)=addsl(sl,(yyvsp[(9) - (9)].sl));
         ;}
    break;

  case 94:

/* Line 1464 of yacc.c  */
#line 1717 "vhd2vl.y"
    {
         slist *sl;
         sglist *sg;
         char *s;

           s=sbottom((yyvsp[(2) - (8)].ss)->sl);
           if((sg=lookup(io_list,s))==NULL)
             sg=lookup(sig_list,s);
           if(sg)
             sg->type=reg;
           sl=addsl((yyvsp[(1) - (8)].sl),indents[indent]);
           sl=addsl(sl,(yyvsp[(2) - (8)].ss)->sl);
           findothers((yyvsp[(2) - (8)].ss),(yyvsp[(6) - (8)].sl));
           sl=addtxt(sl," <= ");
           sl=addsl(sl,(yyvsp[(6) - (8)].sl));
           sl=addtxt(sl,";\n");
           (yyval.sl)=addsl(sl,(yyvsp[(8) - (8)].sl));
         ;}
    break;

  case 95:

/* Line 1464 of yacc.c  */
#line 1736 "vhd2vl.y"
    {
         slist *sl;
           sl=addsl((yyvsp[(1) - (12)].sl),indents[indent]);
           sl=addtxt(sl,"if(");
           sl=addsl(sl,(yyvsp[(3) - (12)].sl));
           sl=addtxt(sl,") begin\n");
           sl=addsl(sl,(yyvsp[(6) - (12)].sl));
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n");
           sl=addsl(sl,(yyvsp[(8) - (12)].sl));
           (yyval.sl)=addsl(sl,(yyvsp[(12) - (12)].sl));
         ;}
    break;

  case 96:

/* Line 1464 of yacc.c  */
#line 1749 "vhd2vl.y"
    {
         slist *sl;
           sl=addsl((yyvsp[(1) - (15)].sl),indents[indent]);
           sl=addtxt(sl,"for (");
           sl=addsl(sl,(yyvsp[(3) - (15)].ss)->sl); /* signal */
           sl=addtxt(sl,"=");
           sl=addsl(sl,(yyvsp[(5) - (15)].e)->sl); /* expr:1 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[(3) - (15)].ss)->sl); /* signal */
           sl=addtxt(sl," <= ");
           sl=addsl(sl,(yyvsp[(7) - (15)].e)->sl); /* expr:2 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[(3) - (15)].ss)->sl); /* signal */
           sl=addtxt(sl," = ");
           sl=addsl(sl,(yyvsp[(3) - (15)].ss)->sl); /* signal */
           sl=addtxt(sl," + 1) begin\n");
           sl=addsl(sl,(yyvsp[(10) - (15)].sl));    /* p_body:1 */
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n");
           (yyval.sl)=addsl(sl,(yyvsp[(15) - (15)].sl));    /* p_body:2 */
         ;}
    break;

  case 97:

/* Line 1464 of yacc.c  */
#line 1771 "vhd2vl.y"
    {
         slist *sl;
           sl=addsl((yyvsp[(1) - (15)].sl),indents[indent]);
           sl=addtxt(sl,"for (");
           sl=addsl(sl,(yyvsp[(3) - (15)].ss)->sl); /* signal */
           sl=addtxt(sl,"=");
           sl=addsl(sl,(yyvsp[(5) - (15)].e)->sl); /* expr:1 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[(3) - (15)].ss)->sl); /* signal */
           sl=addtxt(sl," >= ");
           sl=addsl(sl,(yyvsp[(7) - (15)].e)->sl); /* expr:2 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[(3) - (15)].ss)->sl); /* signal */
           sl=addtxt(sl," = ");
           sl=addsl(sl,(yyvsp[(3) - (15)].ss)->sl); /* signal */
           sl=addtxt(sl," - 1) begin\n");
           sl=addsl(sl,(yyvsp[(10) - (15)].sl));    /* p_body:1 */
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n");
           (yyval.sl)=addsl(sl,(yyvsp[(15) - (15)].sl));    /* p_body:2 */
         ;}
    break;

  case 98:

/* Line 1464 of yacc.c  */
#line 1793 "vhd2vl.y"
    {
         slist *sl;
           sl=addsl((yyvsp[(1) - (10)].sl),indents[indent]);
           sl=addtxt(sl,"case(");
           sl=addsl(sl,(yyvsp[(3) - (10)].ss)->sl); /* signal */
           sl=addtxt(sl,")\n");
           if((yyvsp[(5) - (10)].sl)){
             sl=addsl(sl,indents[indent]);
             sl=addsl(sl,(yyvsp[(5) - (10)].sl));
           }
           sl=addsl(sl,(yyvsp[(6) - (10)].sl));
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"endcase\n");
           (yyval.sl)=addsl(sl,(yyvsp[(10) - (10)].sl));
         ;}
    break;

  case 99:

/* Line 1464 of yacc.c  */
#line 1808 "vhd2vl.y"
    {
         slist *sl;
           sl=addsl((yyvsp[(1) - (4)].sl),indents[indent]);
           sl=addtxt(sl,"disable;  //VHD2VL: add block name here\n");
           (yyval.sl)=addsl(sl,(yyvsp[(4) - (4)].sl));
         ;}
    break;

  case 100:

/* Line 1464 of yacc.c  */
#line 1814 "vhd2vl.y"
    {
         slist *sl;
           if((yyvsp[(1) - (4)].sl)){
             sl=addsl((yyvsp[(1) - (4)].sl),indents[indent]);
             (yyval.sl)=addsl(sl,(yyvsp[(4) - (4)].sl));
           }else
             (yyval.sl)=(yyvsp[(4) - (4)].sl);
         ;}
    break;

  case 101:

/* Line 1464 of yacc.c  */
#line 1824 "vhd2vl.y"
    {(yyval.sl)=NULL;;}
    break;

  case 102:

/* Line 1464 of yacc.c  */
#line 1825 "vhd2vl.y"
    {
           slist *sl;
             sl=addtxt(indents[indent],"else if(");
             sl=addsl(sl,(yyvsp[(2) - (7)].sl));
             sl=addtxt(sl,") begin\n");
             sl=addsl(sl,(yyvsp[(5) - (7)].sl));
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"end\n");
             (yyval.sl)=addsl(sl,(yyvsp[(7) - (7)].sl));
           ;}
    break;

  case 103:

/* Line 1464 of yacc.c  */
#line 1835 "vhd2vl.y"
    {
           slist *sl;
             sl=addtxt(indents[indent],"else begin\n");
             sl=addsl(sl,(yyvsp[(3) - (4)].sl));
             sl=addsl(sl,indents[indent]);
             (yyval.sl)=addtxt(sl,"end\n");
           ;}
    break;

  case 104:

/* Line 1464 of yacc.c  */
#line 1844 "vhd2vl.y"
    {
        slist *sl;
          sl=addsl(indents[indent],(yyvsp[(2) - (8)].sl));
          sl=addtxt(sl," : begin\n");
          sl=addsl(sl,(yyvsp[(6) - (8)].sl));
          sl=addsl(sl,indents[indent]);
          sl=addtxt(sl,"end\n");
          (yyval.sl)=addsl(sl,(yyvsp[(8) - (8)].sl));
        ;}
    break;

  case 105:

/* Line 1464 of yacc.c  */
#line 1853 "vhd2vl.y"
    {
        slist *sl;
          sl=addtxt(indents[indent],"default : begin\n");
          sl=addsl(sl,(yyvsp[(6) - (7)].sl));
          sl=addsl(sl,indents[indent]);
          (yyval.sl)=addtxt(sl,"end\n");
        ;}
    break;

  case 106:

/* Line 1464 of yacc.c  */
#line 1860 "vhd2vl.y"
    { (yyval.sl)=NULL; ;}
    break;

  case 107:

/* Line 1464 of yacc.c  */
#line 1863 "vhd2vl.y"
    {(yyval.sl)=(yyvsp[(1) - (1)].sl);;}
    break;

  case 108:

/* Line 1464 of yacc.c  */
#line 1864 "vhd2vl.y"
    {
        slist *sl;
          sl=addtxt((yyvsp[(1) - (3)].sl),",");
          (yyval.sl)=addsl(sl,(yyvsp[(3) - (3)].sl));
        ;}
    break;

  case 109:

/* Line 1464 of yacc.c  */
#line 1871 "vhd2vl.y"
    {(yyval.sl)=addvec(NULL,(yyvsp[(1) - (1)].txt));;}
    break;

  case 110:

/* Line 1464 of yacc.c  */
#line 1872 "vhd2vl.y"
    {(yyval.sl)=addvec_base(NULL,(yyvsp[(1) - (2)].txt),(yyvsp[(2) - (2)].txt));;}
    break;

  case 111:

/* Line 1464 of yacc.c  */
#line 1873 "vhd2vl.y"
    {(yyval.sl)=addtxt(NULL,(yyvsp[(1) - (1)].txt));;}
    break;

  case 112:

/* Line 1464 of yacc.c  */
#line 1876 "vhd2vl.y"
    {(yyval.sl)=(yyvsp[(1) - (1)].ss)->sl; free((yyvsp[(1) - (1)].ss));;}
    break;

  case 113:

/* Line 1464 of yacc.c  */
#line 1877 "vhd2vl.y"
    {
            slist *sl;
              sl=addtxt((yyvsp[(1) - (3)].ss)->sl," or ");
              free((yyvsp[(1) - (3)].ss));
              (yyval.sl)=addsl(sl,(yyvsp[(3) - (3)].sl));
            ;}
    break;

  case 114:

/* Line 1464 of yacc.c  */
#line 1885 "vhd2vl.y"
    {
           slist *sl;
             if(delay && (yyvsp[(2) - (3)].n)){
               sl=addtxt(NULL,"# ");
               sl=addval(sl,(yyvsp[(2) - (3)].n));
               sl=addtxt(sl," ");
             } else
               sl=NULL;
             if((yyvsp[(1) - (3)].e)->op == 'c')
               sl=addsl(sl,addwrap("{",(yyvsp[(1) - (3)].e)->sl,"}"));
             else
               sl=addsl(sl,(yyvsp[(1) - (3)].e)->sl);
             free((yyvsp[(1) - (3)].e));
             delay=1;
             (yyval.sl)=sl;
           ;}
    break;

  case 115:

/* Line 1464 of yacc.c  */
#line 1901 "vhd2vl.y"
    {
             fprintf(stderr,"Warning on line %d: Can't translate 'expr delay WHEN exprc;' expressions\n",lineno);
             (yyval.sl)=NULL;
           ;}
    break;

  case 116:

/* Line 1464 of yacc.c  */
#line 1905 "vhd2vl.y"
    {
           slist *sl;
             sl=addtxt((yyvsp[(4) - (7)].sl)," ? ");
             if((yyvsp[(1) - (7)].e)->op == 'c')
               sl=addsl(sl,addwrap("{",(yyvsp[(1) - (7)].e)->sl,"}"));
             else
               sl=addsl(sl,(yyvsp[(1) - (7)].e)->sl);
             free((yyvsp[(1) - (7)].e));
             sl=addtxt(sl," : ");
             (yyval.sl)=addsl(sl,(yyvsp[(7) - (7)].sl));
           ;}
    break;

  case 117:

/* Line 1464 of yacc.c  */
#line 1918 "vhd2vl.y"
    {delay=0;;}
    break;

  case 118:

/* Line 1464 of yacc.c  */
#line 1921 "vhd2vl.y"
    {(yyval.n)=0;;}
    break;

  case 119:

/* Line 1464 of yacc.c  */
#line 1922 "vhd2vl.y"
    {
             set_timescale((yyvsp[(3) - (3)].txt));
             (yyval.n)=(yyvsp[(2) - (3)].n);
           ;}
    break;

  case 120:

/* Line 1464 of yacc.c  */
#line 1928 "vhd2vl.y"
    {
           slist *sl;
           sl=addsl((yyvsp[(1) - (2)].sl),indents[indent]);
           (yyval.sl)=addsl(sl,(yyvsp[(2) - (2)].sl));;}
    break;

  case 121:

/* Line 1464 of yacc.c  */
#line 1932 "vhd2vl.y"
    {
           slist *sl;
             sl=addsl((yyvsp[(1) - (4)].sl),indents[indent]);
             sl=addsl(sl,(yyvsp[(2) - (4)].sl));
             sl=addtxt(sl,",\n");
             (yyval.sl)=addsl(sl,(yyvsp[(4) - (4)].sl));
           ;}
    break;

  case 122:

/* Line 1464 of yacc.c  */
#line 1941 "vhd2vl.y"
    {(yyval.sl)=(yyvsp[(1) - (1)].sl);;}
    break;

  case 123:

/* Line 1464 of yacc.c  */
#line 1942 "vhd2vl.y"
    {
           slist *sl;
             sl=addtxt(NULL,".");
             sl=addtxt(sl,(yyvsp[(1) - (4)].txt));
             sl=addtxt(sl,"(");
             sl=addsl(sl,(yyvsp[(4) - (4)].sl));
             (yyval.sl)=addtxt(sl,")");
           ;}
    break;

  case 124:

/* Line 1464 of yacc.c  */
#line 1952 "vhd2vl.y"
    {(yyval.sl)=addvec(NULL,(yyvsp[(1) - (1)].txt));;}
    break;

  case 125:

/* Line 1464 of yacc.c  */
#line 1953 "vhd2vl.y"
    {(yyval.sl)=addsl(NULL,(yyvsp[(1) - (1)].ss)->sl);;}
    break;

  case 126:

/* Line 1464 of yacc.c  */
#line 1954 "vhd2vl.y"
    {(yyval.sl)=addval(NULL,(yyvsp[(1) - (1)].n));;}
    break;

  case 127:

/* Line 1464 of yacc.c  */
#line 1955 "vhd2vl.y"
    {(yyval.sl)=addvec_base(NULL,(yyvsp[(1) - (2)].txt),(yyvsp[(2) - (2)].txt));;}
    break;

  case 128:

/* Line 1464 of yacc.c  */
#line 1956 "vhd2vl.y"
    {(yyval.sl)=addtxt(NULL,"/* open */");;}
    break;

  case 129:

/* Line 1464 of yacc.c  */
#line 1957 "vhd2vl.y"
    {
             (yyval.sl)=addtxt(NULL,"{broken{");
             (yyval.sl)=addtxt((yyval.sl),(yyvsp[(5) - (6)].txt));
             (yyval.sl)=addtxt((yyval.sl),"}}");
             fprintf(stderr,"Warning on line %d: broken width on port with OTHERS\n",lineno);
           ;}
    break;

  case 130:

/* Line 1464 of yacc.c  */
#line 1966 "vhd2vl.y"
    {
           slist *sl;
           sl=addsl((yyvsp[(1) - (2)].sl),indents[indent]);
           (yyval.sl)=addsl(sl,(yyvsp[(2) - (2)].sl));;}
    break;

  case 131:

/* Line 1464 of yacc.c  */
#line 1970 "vhd2vl.y"
    {
           slist *sl;
             sl=addsl((yyvsp[(1) - (4)].sl),indents[indent]);
             sl=addsl(sl,(yyvsp[(2) - (4)].sl));
             sl=addtxt(sl,",\n");
             (yyval.sl)=addsl(sl,(yyvsp[(4) - (4)].sl));
           ;}
    break;

  case 132:

/* Line 1464 of yacc.c  */
#line 1977 "vhd2vl.y"
    {  /* only allow a single un-named map item */
             (yyval.sl)=addsl(NULL,(yyvsp[(2) - (2)].e)->sl);
           ;}
    break;

  case 133:

/* Line 1464 of yacc.c  */
#line 1982 "vhd2vl.y"
    {
           slist *sl;
             sl=addtxt(NULL,".");
             sl=addtxt(sl,(yyvsp[(1) - (4)].txt));
             sl=addtxt(sl,"(");
             sl=addsl(sl,(yyvsp[(4) - (4)].e)->sl);
             (yyval.sl)=addtxt(sl,")");
           ;}
    break;

  case 134:

/* Line 1464 of yacc.c  */
#line 1992 "vhd2vl.y"
    {
         slist *sl;
         slval *ss;
           ss=xmalloc(sizeof(slval));
           sl=addtxt(NULL,(yyvsp[(1) - (1)].txt));
           if(dowith){
             slwith=sl;
             dowith=0;
           }
           ss->sl=sl;
           ss->val=-1;
           ss->range=NULL;
           (yyval.ss)=ss;
         ;}
    break;

  case 135:

/* Line 1464 of yacc.c  */
#line 2006 "vhd2vl.y"
    {
         slval *ss;
         slist *sl;
           ss=xmalloc(sizeof(slval));
           sl=addtxt(NULL,(yyvsp[(1) - (4)].txt));
           sl=addpar_snug(sl,(yyvsp[(3) - (4)].v));
           if(dowith){
             slwith=sl;
             dowith=0;
           }
           ss->sl=sl;
           ss->range=(yyvsp[(3) - (4)].v);
           if((yyvsp[(3) - (4)].v)->vtype==tVRANGE) {
             if (0) {
               fprintf(stderr,"ss->val set to 1 for ");
               fslprint(stderr,ss->sl);
               fprintf(stderr,", why?\n");
             }
             ss->val = -1; /* width is in the vrange */
           } else {
             ss->val = 1;
           }
           (yyval.ss)=ss;
         ;}
    break;

  case 136:

/* Line 1464 of yacc.c  */
#line 2030 "vhd2vl.y"
    {
         slval *ss;
         slist *sl;
           ss=xmalloc(sizeof(slval));
           sl=addtxt(NULL,(yyvsp[(1) - (7)].txt));
           sl=addpar_snug2(sl,(yyvsp[(3) - (7)].v), (yyvsp[(6) - (7)].v));
           if(dowith){
             slwith=sl;
             dowith=0;
           }
           ss->sl=sl;
           ss->range=(yyvsp[(3) - (7)].v);
           if((yyvsp[(3) - (7)].v)->vtype==tVRANGE) {
             ss->val = -1; /* width is in the vrange */
           } else {
             ss->val = 1;
           }
           (yyval.ss)=ss;
         ;}
    break;

  case 137:

/* Line 1464 of yacc.c  */
#line 2052 "vhd2vl.y"
    {
         expdata *e;
           e=xmalloc(sizeof(expdata));
           e->op='t'; /* Terminal symbol */
           e->sl=(yyvsp[(1) - (1)].ss)->sl;
           free((yyvsp[(1) - (1)].ss));
           (yyval.e)=e;
         ;}
    break;

  case 138:

/* Line 1464 of yacc.c  */
#line 2060 "vhd2vl.y"
    {
         expdata *e;
           e=xmalloc(sizeof(expdata));
           e->op='t'; /* Terminal symbol */
           e->sl=addvec(NULL,(yyvsp[(1) - (1)].txt));
           (yyval.e)=e;
         ;}
    break;

  case 139:

/* Line 1464 of yacc.c  */
#line 2067 "vhd2vl.y"
    {
         expdata *e=xmalloc(sizeof(expdata));
           e->op='t'; /* Terminal symbol */
           e->sl=addtxt(NULL,(yyvsp[(1) - (1)].txt));
           (yyval.e)=e;
         ;}
    break;

  case 140:

/* Line 1464 of yacc.c  */
#line 2073 "vhd2vl.y"
    {
         expdata *e=xmalloc(sizeof(expdata));
           e->op='t'; /* Terminal symbol */
           e->sl=addval(NULL,(yyvsp[(1) - (1)].n));
           (yyval.e)=e;
         ;}
    break;

  case 141:

/* Line 1464 of yacc.c  */
#line 2079 "vhd2vl.y"
    {  /* e.g. 16#55aa# */
         /* XXX unify this code with addvec_base */
         expdata *e=xmalloc(sizeof(expdata));
         char *natval = xmalloc(strlen((yyvsp[(2) - (2)].txt))+34);
           e->op='t'; /* Terminal symbol */
           switch((yyvsp[(1) - (2)].n)) {
           case  2:
             sprintf(natval, "'B%s",(yyvsp[(2) - (2)].txt));
             break;
           case  8:
             sprintf(natval, "'O%s",(yyvsp[(2) - (2)].txt));
             break;
           case 10:
             sprintf(natval, "'D%s",(yyvsp[(2) - (2)].txt));
             break;
           case 16:
             sprintf(natval, "'H%s",(yyvsp[(2) - (2)].txt));
             break;
           default:
             sprintf(natval,"%d#%s#",(yyvsp[(1) - (2)].n),(yyvsp[(2) - (2)].txt));
             fprintf(stderr,"Warning on line %d: Can't translate based number %s (only bases of 2, 8, 10, and 16 are translatable)\n",lineno,natval);
           }
           e->sl=addtxt(NULL,natval);
           (yyval.e)=e;
         ;}
    break;

  case 142:

/* Line 1464 of yacc.c  */
#line 2104 "vhd2vl.y"
    {
         expdata *e=xmalloc(sizeof(expdata));
           e->op='t'; /* Terminal symbol */
           e->sl=addvec_base(NULL,(yyvsp[(1) - (2)].txt),(yyvsp[(2) - (2)].txt));
           (yyval.e)=e;
         ;}
    break;

  case 143:

/* Line 1464 of yacc.c  */
#line 2110 "vhd2vl.y"
    {
         expdata *e;
           e=xmalloc(sizeof(expdata));
           e->op='o'; /* others */
           e->sl=addothers(NULL,(yyvsp[(5) - (6)].txt));
           (yyval.e)=e;
         ;}
    break;

  case 144:

/* Line 1464 of yacc.c  */
#line 2117 "vhd2vl.y"
    { /* Vector chaining */
         slist *sl;
           sl=addtxt((yyvsp[(1) - (3)].e)->sl,",");
           sl=addsl(sl,(yyvsp[(3) - (3)].e)->sl);
           free((yyvsp[(3) - (3)].e));
           (yyvsp[(1) - (3)].e)->op='c';
           (yyvsp[(1) - (3)].e)->sl=sl;
           (yyval.e)=(yyvsp[(1) - (3)].e);
         ;}
    break;

  case 145:

/* Line 1464 of yacc.c  */
#line 2126 "vhd2vl.y"
    {(yyval.e)=addexpr(NULL,'m'," -",(yyvsp[(2) - (2)].e));;}
    break;

  case 146:

/* Line 1464 of yacc.c  */
#line 2127 "vhd2vl.y"
    {(yyval.e)=addexpr(NULL,'p'," +",(yyvsp[(2) - (2)].e));;}
    break;

  case 147:

/* Line 1464 of yacc.c  */
#line 2128 "vhd2vl.y"
    {(yyval.e)=addexpr((yyvsp[(1) - (3)].e),'+'," + ",(yyvsp[(3) - (3)].e));;}
    break;

  case 148:

/* Line 1464 of yacc.c  */
#line 2129 "vhd2vl.y"
    {(yyval.e)=addexpr((yyvsp[(1) - (3)].e),'-'," - ",(yyvsp[(3) - (3)].e));;}
    break;

  case 149:

/* Line 1464 of yacc.c  */
#line 2130 "vhd2vl.y"
    {(yyval.e)=addexpr((yyvsp[(1) - (3)].e),'*'," * ",(yyvsp[(3) - (3)].e));;}
    break;

  case 150:

/* Line 1464 of yacc.c  */
#line 2131 "vhd2vl.y"
    {(yyval.e)=addexpr((yyvsp[(1) - (3)].e),'/'," / ",(yyvsp[(3) - (3)].e));;}
    break;

  case 151:

/* Line 1464 of yacc.c  */
#line 2132 "vhd2vl.y"
    {(yyval.e)=addexpr((yyvsp[(1) - (3)].e),'%'," % ",(yyvsp[(3) - (3)].e));;}
    break;

  case 152:

/* Line 1464 of yacc.c  */
#line 2133 "vhd2vl.y"
    {(yyval.e)=addexpr(NULL,'~'," ~",(yyvsp[(2) - (2)].e));;}
    break;

  case 153:

/* Line 1464 of yacc.c  */
#line 2134 "vhd2vl.y"
    {(yyval.e)=addexpr((yyvsp[(1) - (3)].e),'&'," & ",(yyvsp[(3) - (3)].e));;}
    break;

  case 154:

/* Line 1464 of yacc.c  */
#line 2135 "vhd2vl.y"
    {(yyval.e)=addexpr((yyvsp[(1) - (3)].e),'|'," | ",(yyvsp[(3) - (3)].e));;}
    break;

  case 155:

/* Line 1464 of yacc.c  */
#line 2136 "vhd2vl.y"
    {(yyval.e)=addexpr((yyvsp[(1) - (3)].e),'^'," ^ ",(yyvsp[(3) - (3)].e));;}
    break;

  case 156:

/* Line 1464 of yacc.c  */
#line 2137 "vhd2vl.y"
    {(yyval.e)=addexpr(NULL,'~'," ~",addexpr((yyvsp[(1) - (3)].e),'^'," ^ ",(yyvsp[(3) - (3)].e)));;}
    break;

  case 157:

/* Line 1464 of yacc.c  */
#line 2138 "vhd2vl.y"
    {
       /* single argument type conversion function e.g. std_ulogic_vector(x) */
       expdata *e;
       e=xmalloc(sizeof(expdata));
       if ((yyvsp[(3) - (4)].e)->op == 'c') {
         e->sl=addwrap("{",(yyvsp[(3) - (4)].e)->sl,"}");
       } else {
         e->sl=addwrap("(",(yyvsp[(3) - (4)].e)->sl,")");
       }
       (yyval.e)=e;
      ;}
    break;

  case 158:

/* Line 1464 of yacc.c  */
#line 2149 "vhd2vl.y"
    {
       /* two argument type conversion e.g. to_unsigned(x, 3) */
       (yyval.e) = addnest((yyvsp[(3) - (6)].e));
      ;}
    break;

  case 159:

/* Line 1464 of yacc.c  */
#line 2153 "vhd2vl.y"
    {
       (yyval.e) = addnest((yyvsp[(3) - (6)].e));
      ;}
    break;

  case 160:

/* Line 1464 of yacc.c  */
#line 2156 "vhd2vl.y"
    {
       (yyval.e) = addnest((yyvsp[(2) - (3)].e));
      ;}
    break;

  case 161:

/* Line 1464 of yacc.c  */
#line 2162 "vhd2vl.y"
    { (yyval.sl)=(yyvsp[(1) - (1)].sl); ;}
    break;

  case 162:

/* Line 1464 of yacc.c  */
#line 2163 "vhd2vl.y"
    {
         (yyval.sl)=addwrap("(",(yyvsp[(2) - (3)].sl),")");
      ;}
    break;

  case 163:

/* Line 1464 of yacc.c  */
#line 2166 "vhd2vl.y"
    {
        slist *sl;
          sl=addtxt((yyvsp[(1) - (3)].sl)," && ");
          (yyval.sl)=addsl(sl,(yyvsp[(3) - (3)].sl));
        ;}
    break;

  case 164:

/* Line 1464 of yacc.c  */
#line 2171 "vhd2vl.y"
    {
        slist *sl;
          sl=addtxt((yyvsp[(1) - (3)].sl)," || ");
          (yyval.sl)=addsl(sl,(yyvsp[(3) - (3)].sl));
        ;}
    break;

  case 165:

/* Line 1464 of yacc.c  */
#line 2176 "vhd2vl.y"
    {
        slist *sl;
          sl=addtxt(NULL,"!");
          (yyval.sl)=addsl(sl,(yyvsp[(2) - (2)].sl));
        ;}
    break;

  case 166:

/* Line 1464 of yacc.c  */
#line 2184 "vhd2vl.y"
    {
       slist *sl;
         if((yyvsp[(1) - (3)].e)->op == 'c')
           sl=addwrap("{",(yyvsp[(1) - (3)].e)->sl,"} == ");
         else if((yyvsp[(1) - (3)].e)->op != 't')
           sl=addwrap("(",(yyvsp[(1) - (3)].e)->sl,") == ");
         else
           sl=addtxt((yyvsp[(1) - (3)].e)->sl," == ");
         if((yyvsp[(3) - (3)].e)->op == 'c')
           (yyval.sl)=addsl(sl,addwrap("{",(yyvsp[(3) - (3)].e)->sl,"}"));
         else if((yyvsp[(3) - (3)].e)->op != 't')
           (yyval.sl)=addsl(sl,addwrap("(",(yyvsp[(3) - (3)].e)->sl,")"));
         else
           (yyval.sl)=addsl(sl,(yyvsp[(3) - (3)].e)->sl);
         free((yyvsp[(1) - (3)].e));
         free((yyvsp[(3) - (3)].e));
       ;}
    break;

  case 167:

/* Line 1464 of yacc.c  */
#line 2201 "vhd2vl.y"
    {
       slist *sl;
         if((yyvsp[(1) - (3)].e)->op == 'c')
           sl=addwrap("{",(yyvsp[(1) - (3)].e)->sl,"} > ");
         else if((yyvsp[(1) - (3)].e)->op != 't')
           sl=addwrap("(",(yyvsp[(1) - (3)].e)->sl,") > ");
         else
           sl=addtxt((yyvsp[(1) - (3)].e)->sl," > ");
         if((yyvsp[(3) - (3)].e)->op == 'c')
           (yyval.sl)=addsl(sl,addwrap("{",(yyvsp[(3) - (3)].e)->sl,"}"));
         else if((yyvsp[(3) - (3)].e)->op != 't')
           (yyval.sl)=addsl(sl,addwrap("(",(yyvsp[(3) - (3)].e)->sl,")"));
         else
           (yyval.sl)=addsl(sl,(yyvsp[(3) - (3)].e)->sl);
         free((yyvsp[(1) - (3)].e));
         free((yyvsp[(3) - (3)].e));
       ;}
    break;

  case 168:

/* Line 1464 of yacc.c  */
#line 2218 "vhd2vl.y"
    {
       slist *sl;
         if((yyvsp[(1) - (4)].e)->op == 'c')
           sl=addwrap("{",(yyvsp[(1) - (4)].e)->sl,"} >= ");
         else if((yyvsp[(1) - (4)].e)->op != 't')
           sl=addwrap("(",(yyvsp[(1) - (4)].e)->sl,") >= ");
         else
           sl=addtxt((yyvsp[(1) - (4)].e)->sl," >= ");
         if((yyvsp[(4) - (4)].e)->op == 'c')
           (yyval.sl)=addsl(sl,addwrap("{",(yyvsp[(4) - (4)].e)->sl,"}"));
         else if((yyvsp[(4) - (4)].e)->op != 't')
           (yyval.sl)=addsl(sl,addwrap("(",(yyvsp[(4) - (4)].e)->sl,")"));
         else
           (yyval.sl)=addsl(sl,(yyvsp[(4) - (4)].e)->sl);
         free((yyvsp[(1) - (4)].e));
         free((yyvsp[(4) - (4)].e));
       ;}
    break;

  case 169:

/* Line 1464 of yacc.c  */
#line 2235 "vhd2vl.y"
    {
       slist *sl;
         if((yyvsp[(1) - (3)].e)->op == 'c')
           sl=addwrap("{",(yyvsp[(1) - (3)].e)->sl,"} < ");
         else if((yyvsp[(1) - (3)].e)->op != 't')
           sl=addwrap("(",(yyvsp[(1) - (3)].e)->sl,") < ");
         else
           sl=addtxt((yyvsp[(1) - (3)].e)->sl," < ");
         if((yyvsp[(3) - (3)].e)->op == 'c')
           (yyval.sl)=addsl(sl,addwrap("{",(yyvsp[(3) - (3)].e)->sl,"}"));
         else if((yyvsp[(3) - (3)].e)->op != 't')
           (yyval.sl)=addsl(sl,addwrap("(",(yyvsp[(3) - (3)].e)->sl,")"));
         else
           (yyval.sl)=addsl(sl,(yyvsp[(3) - (3)].e)->sl);
         free((yyvsp[(1) - (3)].e));
         free((yyvsp[(3) - (3)].e));
       ;}
    break;

  case 170:

/* Line 1464 of yacc.c  */
#line 2252 "vhd2vl.y"
    {
       slist *sl;
         if((yyvsp[(1) - (4)].e)->op == 'c')
           sl=addwrap("{",(yyvsp[(1) - (4)].e)->sl,"} <= ");
         else if((yyvsp[(1) - (4)].e)->op != 't')
           sl=addwrap("(",(yyvsp[(1) - (4)].e)->sl,") <= ");
         else
           sl=addtxt((yyvsp[(1) - (4)].e)->sl," <= ");
         if((yyvsp[(4) - (4)].e)->op == 'c')
           (yyval.sl)=addsl(sl,addwrap("{",(yyvsp[(4) - (4)].e)->sl,"}"));
         else if((yyvsp[(4) - (4)].e)->op != 't')
           (yyval.sl)=addsl(sl,addwrap("(",(yyvsp[(4) - (4)].e)->sl,")"));
         else
           (yyval.sl)=addsl(sl,(yyvsp[(4) - (4)].e)->sl);
         free((yyvsp[(1) - (4)].e));
         free((yyvsp[(4) - (4)].e));
       ;}
    break;

  case 171:

/* Line 1464 of yacc.c  */
#line 2269 "vhd2vl.y"
    {
       slist *sl;
         if((yyvsp[(1) - (4)].e)->op == 'c')
           sl=addwrap("{",(yyvsp[(1) - (4)].e)->sl,"} != ");
         else if((yyvsp[(1) - (4)].e)->op != 't')
           sl=addwrap("(",(yyvsp[(1) - (4)].e)->sl,") != ");
         else
           sl=addtxt((yyvsp[(1) - (4)].e)->sl," != ");
         if((yyvsp[(4) - (4)].e)->op == 'c')
           (yyval.sl)=addsl(sl,addwrap("{",(yyvsp[(4) - (4)].e)->sl,"}"));
         else if((yyvsp[(4) - (4)].e)->op != 't')
           (yyval.sl)=addsl(sl,addwrap("(",(yyvsp[(4) - (4)].e)->sl,")"));
         else
           (yyval.sl)=addsl(sl,(yyvsp[(4) - (4)].e)->sl);
         free((yyvsp[(1) - (4)].e));
         free((yyvsp[(4) - (4)].e));
       ;}
    break;

  case 172:

/* Line 1464 of yacc.c  */
#line 2288 "vhd2vl.y"
    {
         expdata *e;
         e=xmalloc(sizeof(expdata));
         e->op='t'; /* Terminal symbol */
         e->sl=(yyvsp[(1) - (1)].ss)->sl;
         free((yyvsp[(1) - (1)].ss));
         (yyval.e)=e;
      ;}
    break;

  case 173:

/* Line 1464 of yacc.c  */
#line 2296 "vhd2vl.y"
    {
         expdata *e;
         e=xmalloc(sizeof(expdata));
         e->op='t'; /* Terminal symbol */
         e->sl=addvec(NULL,(yyvsp[(1) - (1)].txt));
         (yyval.e)=e;
      ;}
    break;

  case 174:

/* Line 1464 of yacc.c  */
#line 2303 "vhd2vl.y"
    {
         expdata *e;
         e=xmalloc(sizeof(expdata));
         e->op='n'; /* natural */
         e->value=(yyvsp[(1) - (1)].n);
         e->sl=addval(NULL,(yyvsp[(1) - (1)].n));
         (yyval.e)=e;
      ;}
    break;

  case 175:

/* Line 1464 of yacc.c  */
#line 2311 "vhd2vl.y"
    {
       (yyval.e)=addexpr((yyvsp[(1) - (3)].e),'+'," + ",(yyvsp[(3) - (3)].e));
      ;}
    break;

  case 176:

/* Line 1464 of yacc.c  */
#line 2314 "vhd2vl.y"
    {
       (yyval.e)=addexpr((yyvsp[(1) - (3)].e),'-'," - ",(yyvsp[(3) - (3)].e));
      ;}
    break;

  case 177:

/* Line 1464 of yacc.c  */
#line 2317 "vhd2vl.y"
    {
       (yyval.e)=addexpr((yyvsp[(1) - (3)].e),'*'," * ",(yyvsp[(3) - (3)].e));
      ;}
    break;

  case 178:

/* Line 1464 of yacc.c  */
#line 2320 "vhd2vl.y"
    {
       (yyval.e)=addexpr((yyvsp[(1) - (3)].e),'/'," / ",(yyvsp[(3) - (3)].e));
      ;}
    break;

  case 179:

/* Line 1464 of yacc.c  */
#line 2323 "vhd2vl.y"
    {
       /* one argument type conversion e.g. conv_integer(x) */
       expdata *e;
       e=xmalloc(sizeof(expdata));
       e->sl=addwrap("(",(yyvsp[(3) - (4)].e)->sl,")");
       (yyval.e)=e;
      ;}
    break;

  case 180:

/* Line 1464 of yacc.c  */
#line 2330 "vhd2vl.y"
    {
       expdata *e;
       e=xmalloc(sizeof(expdata));
       e->sl=addwrap("(",(yyvsp[(2) - (3)].e)->sl,")");
       (yyval.e)=e;
      ;}
    break;



/* Line 1464 of yacc.c  */
#line 5167 "vhd2vl.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1684 of yacc.c  */
#line 2338 "vhd2vl.y"


const char *outfile;    /* Output file */
const char *sourcefile; /* Input file */

int main(int argc, char *argv[]){
int i,j;
char *s;
slist *sl;
int status;

  /* Init the indentation variables */
  indents[0]=NULL;
  for(i=1;i<MAXINDENT;i++){
    indents[i]=sl=xmalloc(sizeof(slist));
    sl->data.txt=s=xmalloc(sizeof(char) *((i<<1)+1));
    for(j=0;j<(i<<1);j++)
      *s++=' ';
    *s=0;
    sl->type=1;
    sl->slst=NULL;
  }
  if (argc >= 2 && strcmp(argv[1], "--help") == 0) {
    printf(
      "Usage: vhd2vl [-d] [-g1995|-g2001] source_file.vhd > target_file.v\n"
      "   or  vhd2vl [-d] [-g1995|-g2001] source_file.vhd target_file.v\n");
    exit(EXIT_SUCCESS);
  }

  while (argc >= 2) {
     if (strcmp(argv[1], "-d") == 0) {
       yydebug = 1;
     } else if (strcmp(argv[1], "-g1995") == 0) {
       vlog_ver = 0;
     } else if (strcmp(argv[1], "-g2001") == 0) {
       vlog_ver = 1;
     } else {
       break;
     }
     argv++;
     argc--;
  }
  if (argc>=2) {
     sourcefile = argv[1];
     if (strcmp(sourcefile,"-")!=0 && !freopen(sourcefile, "r", stdin)) {
        fprintf(stderr, "Error: Can't open input file '%s'\n", sourcefile);
        return(1);
     }
  } else {
     sourcefile = "-";
  }

  if (argc>=3) {
     outfile = argv[2];
     if (strcmp(outfile,"-")!=0 && !freopen(outfile, "w", stdout)) {
        fprintf(stderr, "Error: Can't open output file '%s'\n", outfile);
        return(1);
     }
  } else {
     outfile = "-";
  }

  printf("// File %s translated with vhd2vl v2.4 VHDL to Verilog RTL translator\n", sourcefile);
  printf("// vhd2vl settings:\n"
         "//  * Verilog Module Declaration Style: %s\n\n",
         vlog_ver ? "2001" : "1995");
  fputs(
"// vhd2vl is Free (libre) Software:\n"
"//   Copyright (C) 2001 Vincenzo Liguori - Ocean Logic Pty Ltd\n"
"//     http://www.ocean-logic.com\n"
"//   Modifications Copyright (C) 2006 Mark Gonzales - PMC Sierra Inc\n"
"//   Modifications (C) 2010 Shankar Giri\n"
"//   Modifications Copyright (C) 2002, 2005, 2008-2010 Larry Doolittle - LBNL\n"
"//     http://doolittle.icarus.com/~larry/vhd2vl/\n"
"//\n", stdout);
  fputs(
"//   vhd2vl comes with ABSOLUTELY NO WARRANTY.  Always check the resulting\n"
"//   Verilog for correctness, ideally with a formal verification tool.\n"
"//\n"
"//   You are welcome to redistribute vhd2vl under certain conditions.\n"
"//   See the license (GPLv2) file included with the source for details.\n\n"
"// The result of translation follows.  Its copyright status should be\n"
"// considered unchanged from the original VHDL.\n\n"
  , stdout);
  status = yyparse();
  fclose(stdout);
  fclose(stdin);
  if (status != 0 && strcmp(outfile,"-")!=0) unlink(outfile);
  return status;
}

